/***************************************************************************
                          clientsocket.cpp  -  description
                             -------------------
    begin                : Sat Sep 14 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "clientsocket.h"
#include <qtextstream.h>
#include <qtimer.h>

ClientSocket::ClientSocket( int sock, QObject *parent, int id_num, const char *name ) :
    QSocket( parent, name )
{
    connect( this, SIGNAL(readyRead()), SLOT(readClient()) );
    connect( this, SIGNAL(connectionClosed()), SLOT(connectionClosed()) );
    setSocket( sock );
    ID = id_num;
    checkAuth = TRUE;
    QTimer::singleShot( 500, this, SLOT( sendBadAuth() ) );
}

ClientSocket::~ClientSocket()
{
	close();
}

void ClientSocket::sendBadAuth()
{
    if ( checkAuth )
    {
        emit BadAuth( ID );
    }
}

void ClientSocket::readClient()
{
	//qDebug("incoming");
	emit Receiving( TRUE );
    while ( canReadLine() )
	{
        QTextStream os( &str, IO_WriteOnly );
        os <<  readLine();
		//qDebug( str );
    }
	emit Incoming( ID, str );
	emit Receiving( FALSE );
	str = "";
}

void ClientSocket::writeClient( QString s )
{
	emit Sending( TRUE );
	QTextStream os( this );
	os <<  s;
	emit Sending( FALSE );
}

void ClientSocket::connectionClosed()
{
 	emit Closing();
}

