/***************************************************************************
                          errorlog.h  -  description
                             -------------------
    begin                : Tue Aug 27 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef TEXTWINDOW_H
#define TEXTWINDOW_H

#include <qvariant.h>
#include <qwidget.h>
#include <qthread.h>
#include <qpalette.h>

#include "consolewindow.h"

class QTimer;
class RTMix;

class TextWindow : public ConsoleWindow, public QThread
{ 
    Q_OBJECT

public:
    TextWindow( QWidget* parent = 0, RTMix *pointer = 0, const char* name = 0, WFlags fl = 0 );
    ~TextWindow();

    QPalette pal;
    QColorGroup cg;

    void Post( QString s, bool Verbose, int PlaybackStatus, bool CompileFlag, bool RTEB, bool MIDIL,
        long TimeCount, long AbsTimeCount );  
    
public slots:
    void AddText( QString );
    void Clear();

    void TurnARtOff();
    void TurnAOscOff();
    void TurnAMidiOff();
    void TurnAKeysOff();
    void TurnANetIOff();
    void TurnANetOOff();
    
    void ToggleMRt( bool );
    void ToggleMMidi( bool );
    void ToggleMVerbose( bool );
    void ToggleMMidiLog( bool );
    void ToggleMNet( bool );
    void ToggleMNetHost( bool );
    
    void ToggleARt( bool );
    void ToggleAOsc( bool );
    void ToggleAMidi( bool );
    void ToggleAKeys( bool );
    void ToggleANetI( bool );
    void ToggleANetO( bool );    
    void ToggleAWarns( bool );
    void ToggleAErrors( bool );
    void ToggleAPlay( int );  

signals:
    void Closed( int );
    void KeyPress( QKeyEvent* );
    void KeyRelease( QKeyEvent* );
    
protected:
    //QGridLayout* TextWindowLayout;
    bool event( QEvent* ev );
    void closeEvent ( QCloseEvent * );
    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );
    void run();

    QTimer *ARt;
    QTimer *AOsc;
    QTimer *AMidi;
    QTimer *AKeys;
    QTimer *ANetI;
    QTimer *ANetO;

    QPalette Play;
    void  timerEvent( QTimerEvent * );
    bool PlaybackBlink;
    int PlaybackVal;

    RTMix* ptr;
};

#endif // TEXTWINDOW_H
