/***************************************************************************
                          eventcue.h  -  description
                             -------------------
    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EVENTCUE_H
#define EVENTCUE_H

#include "oscevent.h"

struct eventCue {
	QString event;			//event call itself (regardless if it is system call or not)
	QString killEvent;  		//event to be killed when the full stop or "panic" button is used
	QString text;				//text of the event (if any)
	QString say;				//raw info of the say command
	int ID;						//ID number for different types of events
	long time;					//time of the event in seconds.centiseconds
	long countdown;			//time to countdown until the countdown event (or warning) executes  or otherwise generic value
	int absat;					//whether the event responds to the main timer or absolute timer

	long happen;				//whether the event will happen
	long chance;				//chance of happening
	QString color;			//color of the message in web format (or 0 for silent message)
	int light;						//whether the lamp(s) light up
									//0 all is off
									//1 green lights-up for the duration of the "speed" variable
									//2 yellow blinks
									//3 countdown settings
									//4-7 custom lamps that can be invoked (up to four per computer)
									//8-13 for up to 6 lights on a custom widget
	int blinkSpeed;			//speed of blinking (for the light=2)
	long prepLength;		//prep for the countdown (to be used only for countdown)
	long lightLength;			//length of lighting-up or blinking
	int netAddress;			//Network address (optional)

	int bpm;					//Metronome-only object
	int type;					//Randomize and Metronome object
	QString var;				//Var used only for Change object
	int method;				//used for Randomize object
	float amt;					//float-point amount for the ASSIGN object
  
	QString accel;			//Accelerator for the real-time events
    int la, ha, lb, hb, lc, hc; //MIDI limiters

    int last1, last2, last3; //last MIDI events
    int lastTime;

    OSCEvent *OSCPtr; //pointer to optional OSC event

	eventCue *next;		//pointer to next appointment
	eventCue *prev;		//pointer to previous appointment
};

#endif
