/***************************************************************************
                          ledwindow.cpp  -  description
                             -------------------
    begin                : Wed Aug 21 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ledwindow.h"

#include <qframe.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "QLED.h"

/* 
 *  Constructs a LEDWindow which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
LEDWindow::LEDWindow( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
/*
    LED1.load("/usr/local/rtmix/images/multiled.xpm");
    LED1Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED1Green.load("/usr/local/rtmix/images/greenon.xpm");

    LED2.load("/usr/local/rtmix/images/multiled.xpm");
    LED2Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED2Green.load("/usr/local/rtmix/images/greenon.xpm");

    LED3.load("/usr/local/rtmix/images/multiled.xpm");
    LED3Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED3Green.load("/usr/local/rtmix/images/greenon.xpm");

    LED4.load("/usr/local/rtmix/images/multiled.xpm");
    LED4Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED4Green.load("/usr/local/rtmix/images/greenon.xpm");

    LED5.load("/usr/local/rtmix/images/multiled.xpm");
    LED5Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED5Green.load("/usr/local/rtmix/images/greenon.xpm");

    LED6.load("/usr/local/rtmix/images/multiled.xpm");
    LED6Yellow.load("/usr/local/rtmix/images/yellowon.xpm");
    LED6Green.load("/usr/local/rtmix/images/greenon.xpm");
*/
	LED1 = new QPixmap();
	LED1Yellow = new QPixmap();
	LED1Green = new QPixmap();

	LED2 = new QPixmap();
	LED2Yellow = new QPixmap();
	LED2Green = new QPixmap();

	LED3 = new QPixmap();
	LED3Yellow = new QPixmap();
	LED3Green = new QPixmap();

	LED4 = new QPixmap();
	LED4Yellow = new QPixmap();
	LED4Green = new QPixmap();

	LED5 = new QPixmap();
	LED5Yellow = new QPixmap();
	LED5Green = new QPixmap();

	LED6 = new QPixmap();
	LED6Yellow = new QPixmap();
	LED6Green = new QPixmap();


    if ( !name )
	setName( "LEDWindow" );
    resize( 714, 149 ); 
    setMaximumSize( QSize( 1300, 250 ) );
    setCaption( tr( "LED Window" ) );
    LEDWindowLayout = new QGridLayout( this ); 
    LEDWindowLayout->setSpacing( 6 );
    LEDWindowLayout->setMargin( 6 );

    Frame1 = new QFrame( this, "Frame1" );
    Frame1->setMaximumSize( QSize( 212, 248 ) );
    Frame1->setFrameShape( QFrame::Box );
    Frame1->setFrameShadow( QFrame::Sunken );
    Frame1Layout = new QGridLayout( Frame1 ); 
    Frame1Layout->setSpacing( 6 );
    Frame1Layout->setMargin( 6 );

    PixmapLED1 = new QLED( Frame1, "PixmapLED1", WResizeNoErase | WRepaintNoErase );
    PixmapLED1->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED1->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED1->setPixmap( *LED1 );
    PixmapLED1->setScaledContents( TRUE );

    Frame1Layout->addWidget( PixmapLED1, 0, 0 );

    TextLabel1 = new QLabel( Frame1, "TextLabel1" );
    TextLabel1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel1->sizePolicy().hasHeightForWidth() ) );
    TextLabel1->setText( tr( "LED 1" ) );
    TextLabel1->setAlignment( int( QLabel::AlignCenter ) );

    Frame1Layout->addWidget( TextLabel1, 1, 0 );

    LEDWindowLayout->addWidget( Frame1, 0, 0 );

    Frame2 = new QFrame( this, "Frame2" );
    Frame2->setMaximumSize( QSize( 212, 248 ) );
    Frame2->setFrameShape( QFrame::Box );
    Frame2->setFrameShadow( QFrame::Sunken );
    Frame2Layout = new QGridLayout( Frame2 ); 
    Frame2Layout->setSpacing( 6 );
    Frame2Layout->setMargin( 6 );

    PixmapLED2 = new QLED( Frame2, "PixmapLED2", WResizeNoErase | WRepaintNoErase );
    PixmapLED2->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED2->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED2->setPixmap( *LED2 );
    PixmapLED2->setScaledContents( TRUE );

    Frame2Layout->addWidget( PixmapLED2, 0, 0 );

    TextLabel2 = new QLabel( Frame2, "TextLabel2" );
    TextLabel2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel2->sizePolicy().hasHeightForWidth() ) );
    TextLabel2->setText( tr( "LED 2" ) );
    TextLabel2->setAlignment( int( QLabel::AlignCenter ) );

    Frame2Layout->addWidget( TextLabel2, 1, 0 );

    LEDWindowLayout->addWidget( Frame2, 0, 1 );

    Frame3 = new QFrame( this, "Frame3" );
    Frame3->setMaximumSize( QSize( 212, 248 ) );
    Frame3->setFrameShape( QFrame::Box );
    Frame3->setFrameShadow( QFrame::Sunken );
    Frame3Layout = new QGridLayout( Frame3 ); 
    Frame3Layout->setSpacing( 6 );
    Frame3Layout->setMargin( 6 );

    PixmapLED3 = new QLED( Frame3, "PixmapLED3", WResizeNoErase | WRepaintNoErase );
    PixmapLED3->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED3->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED3->setPixmap( *LED3 );
    PixmapLED3->setScaledContents( TRUE );

    Frame3Layout->addWidget( PixmapLED3, 0, 0 );

    TextLabel3 = new QLabel( Frame3, "TextLabel3" );
    TextLabel3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel3->sizePolicy().hasHeightForWidth() ) );
    TextLabel3->setText( tr( "LED 3" ) );
    TextLabel3->setAlignment( int( QLabel::AlignCenter ) );

    Frame3Layout->addWidget( TextLabel3, 1, 0 );

    LEDWindowLayout->addWidget( Frame3, 0, 2 );

    Frame4 = new QFrame( this, "Frame4" );
    Frame4->setMaximumSize( QSize( 212, 248 ) );
    Frame4->setFrameShape( QFrame::Box );
    Frame4->setFrameShadow( QFrame::Sunken );
    Frame4Layout = new QGridLayout( Frame4 ); 
    Frame4Layout->setSpacing( 6 );
    Frame4Layout->setMargin( 6 );

    PixmapLED4 = new QLED( Frame4, "PixmapLED4", WResizeNoErase | WRepaintNoErase );
    PixmapLED4->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED4->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED4->setPixmap( *LED4 );
    PixmapLED4->setScaledContents( TRUE );

    Frame4Layout->addWidget( PixmapLED4, 0, 0 );

    TextLabel4 = new QLabel( Frame4, "TextLabel4" );
    TextLabel4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel4->sizePolicy().hasHeightForWidth() ) );
    TextLabel4->setText( tr( "LED 4" ) );
    TextLabel4->setAlignment( int( QLabel::AlignCenter ) );

    Frame4Layout->addWidget( TextLabel4, 1, 0 );

    LEDWindowLayout->addWidget( Frame4, 0, 3 );

    Frame5 = new QFrame( this, "Frame5" );
    Frame5->setMaximumSize( QSize( 212, 248 ) );
    Frame5->setFrameShape( QFrame::Box );
    Frame5->setFrameShadow( QFrame::Sunken );
    Frame5Layout = new QGridLayout( Frame5 ); 
    Frame5Layout->setSpacing( 6 );
    Frame5Layout->setMargin( 6 );

    PixmapLED5 = new QLED( Frame5, "PixmapLED5", WResizeNoErase | WRepaintNoErase );
    PixmapLED5->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED5->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED5->setPixmap( *LED5 );
    PixmapLED5->setScaledContents( TRUE );

    Frame5Layout->addWidget( PixmapLED5, 0, 0 );

    TextLabel5 = new QLabel( Frame5, "TextLabel5" );
    TextLabel5->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel5->sizePolicy().hasHeightForWidth() ) );
    TextLabel5->setText( tr( "LED 5" ) );
    TextLabel5->setAlignment( int( QLabel::AlignCenter ) );

    Frame5Layout->addWidget( TextLabel5, 1, 0 );

    LEDWindowLayout->addWidget( Frame5, 0, 4 );

    Frame6 = new QFrame( this, "Frame6" );
    Frame6->setMaximumSize( QSize( 212, 248 ) );
    Frame6->setFrameShape( QFrame::Box );
    Frame6->setFrameShadow( QFrame::Sunken );
    Frame6Layout = new QGridLayout( Frame6 );
    Frame6Layout->setSpacing( 6 );
    Frame6Layout->setMargin( 6 );

    PixmapLED6 = new QLED( Frame6, "PixmapLED6", WResizeNoErase | WRepaintNoErase );
    PixmapLED6->setMaximumSize( QSize( 220, 220 ) );
	PixmapLED6->setMinimumSize( QSize( 110, 110 ) );
    PixmapLED6->setPixmap( *LED6 );
    PixmapLED6->setScaledContents( TRUE );

    Frame6Layout->addWidget( PixmapLED6, 0, 0 );

    TextLabel6 = new QLabel( Frame6, "TextLabel6" );
    TextLabel6->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, TextLabel6->sizePolicy().hasHeightForWidth() ) );
    TextLabel6->setText( tr( "LED 6" ) );
    TextLabel6->setAlignment( int( QLabel::AlignCenter ) );

    Frame6Layout->addWidget( TextLabel6, 1, 0 );

    LEDWindowLayout->addWidget( Frame6, 0, 5 );

    for ( int i = 0; i < 6; i++ )
    {
        Timer[i] = -1;
        LightStatus[i] = false;
        cue[i] = new eventCue();
    }

}

/*  
 *  Destroys the object and frees any allocated resources
 */
LEDWindow::~LEDWindow()
{
    // no need to delete child widgets, Qt does it all for us
}

bool LEDWindow::event( QEvent* ev )
{
    bool ret = QWidget::event( ev );
	if ( ev->type() == QEvent::Hide )
	{
     	emit Closed( 0 );
	}
    //if ( ev->type() == QEvent::Resize )
    //{
    //    qDebug( "%d %d", width(), height() );
    //}
    return ret;
}

void LEDWindow::UpdateLED( int nLed, int ledStatus )
{
	QPixmap *Temp;

	if ( nLed == 1 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED1;
				break;
			case 1:
				Temp = LED1Yellow;
				break;
			case 2:
				Temp = LED1Green;
				break;
		}
		PixmapLED1->setPixmap( *Temp );
	}

	if ( nLed == 2 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED2;
				break;
			case 1:
				Temp = LED2Yellow;
				break;
			case 2:
				Temp = LED2Green;
				break;
		}
		PixmapLED2->setPixmap( *Temp );
	}

	if ( nLed == 3 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED3;
				break;
			case 1:
				Temp = LED3Yellow;
				break;
			case 2:
				Temp = LED3Green;
				break;
		}
		PixmapLED3->setPixmap( *Temp );
	}

	if ( nLed == 4 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED4;
				break;
			case 1:
				Temp = LED4Yellow;
				break;
			case 2:
				Temp = LED4Green;
				break;
		}
		PixmapLED4->setPixmap( *Temp );
	}

	if ( nLed == 5 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED5;
				break;
			case 1:
				Temp = LED5Yellow;
				break;
			case 2:
				Temp = LED5Green;
				break;
		}
		PixmapLED5->setPixmap( *Temp );
	}

	if ( nLed == 6 )
	{
		switch ( ledStatus )
		{
			case 0:
				Temp = LED6;
				break;
			case 1:
				Temp = LED6Yellow;
				break;
			case 2:
				Temp = LED6Green;
				break;
		}
		PixmapLED6->setPixmap( *Temp );
	}
}

void LEDWindow::InternalUpdate()
{
    for ( int i = 0; i < 6; i++ )
    {
        if ( Timer[i] >= 0 )
        {
            UpdateDisplay( cue[i], Timer[i]-- );
        }
    }
}

int LEDWindow::UpdateDisplay( struct eventCue *WarningPointer, long timer )
{
    //qDebug("LED");
	int nLed;

    nLed = WarningPointer->light - 7;


	if ( !Status[nLed-1] && timer != 0 || cue[nLed-1] != WarningPointer )
	{
        Status[nLed-1] = true;
        *cue[ nLed-1] = *WarningPointer;
        Timer[ nLed-1] = timer;
		 //WindowLabel->setText( "Here we go!");
	}
	if ( Status[nLed-1] && timer == 0 )
	{
		ResetLED(nLed);
     	Status[nLed-1] = 0;
		return 0;
	}

	//CHECK LIGHT SETTINGS
	if ( WarningPointer->countdown != 0 ) //This means it has Countdown behavior
	{
		if ( timer == WarningPointer->countdown + WarningPointer->lightLength ) //This is first time through
		{
         	UpdateLED( nLed, 1 );
			LightStatus[nLed-1] = true;
		}
		if ( WarningPointer->blinkSpeed != 0 && timer <= WarningPointer->lightLength + WarningPointer->prepLength && timer > WarningPointer->lightLength && float(float(WarningPointer->prepLength + WarningPointer->lightLength - timer)/ float(WarningPointer->blinkSpeed)) == int( (WarningPointer->prepLength + WarningPointer->lightLength - timer)/WarningPointer->blinkSpeed ) ) //blinking zone
		{
        	if ( LightStatus[nLed-1] )
			{
				if ( WarningPointer->prepLength == (timer - WarningPointer->lightLength) && WarningPointer->prepLength != WarningPointer->countdown || (timer - WarningPointer->lightLength) < WarningPointer->prepLength )
				{
           			UpdateLED( nLed, 0 );
					LightStatus[nLed-1] = false;
				}
			}
			else if ( !LightStatus[nLed-1] )
			{
				UpdateLED( nLed, 1 );
				LightStatus[nLed-1] = true;
			}
		}
		if ( timer == WarningPointer->lightLength && WarningPointer->lightLength != 0 )
		{
             	UpdateLED( nLed, 2 );
				LightStatus[nLed-1] = true;         	
		}
	}

	else if ( WarningPointer->blinkSpeed != 0 ) //This means it has blinking element in it
	{
		if ( timer == WarningPointer->lightLength ) //This is first time through
		{
         	UpdateLED( nLed, 1 );
			LightStatus[nLed-1] = true;
		}
		if ( timer < WarningPointer->lightLength && float(float(WarningPointer->lightLength - timer)/float(WarningPointer->blinkSpeed)) == int( (WarningPointer->lightLength - timer)/WarningPointer->blinkSpeed ) ) //blinking zone
		{
        	if ( LightStatus[nLed-1] )
			{
             	UpdateLED( nLed, 0 );
				LightStatus[nLed-1] = false;
			}
			else
			{
				UpdateLED( nLed, 1 );
				LightStatus[nLed-1] = true;
			}
		}
	}
	
	else //Otherwise this is a simple light-up thing
	{
		if ( timer == WarningPointer->lightLength ) //This is first time through
		{
         	UpdateLED( nLed, 2 );
			LightStatus[nLed-1] = true;
		}
	}
	return 0;
}

void LEDWindow::ResetDisplay()
{
	if ( LightStatus )
	{
		PixmapLED1->setPixmap( *LED1 );
		PixmapLED2->setPixmap( *LED2 );
		PixmapLED3->setPixmap( *LED3 );
		PixmapLED4->setPixmap( *LED4 );
		PixmapLED5->setPixmap( *LED5 );
		PixmapLED6->setPixmap( *LED6 );
        for ( int i = 0; i < 6; i++ )
        {
            LightStatus[i] = 0;
            Status[i] = 0;
            Timer[i] = -1;
        }
	}
}

void LEDWindow::ResetLED( int num )
{
	switch ( num )
	{
     	case 1:
			PixmapLED1->setPixmap( *LED1 );
			break;
     	case 2:
			PixmapLED2->setPixmap( *LED2 );
			break;
     	case 3:
			PixmapLED3->setPixmap( *LED3 );
			break;
     	case 4:
			PixmapLED4->setPixmap( *LED4 );
			break;
     	case 5:
			PixmapLED5->setPixmap( *LED5 );
			break;
     	case 6:
			PixmapLED6->setPixmap( *LED6 );
			break;
	}
}

void LEDWindow::SetName( int nLed, QString Title )
{
	//setCaption( WindowTitle );
	if ( nLed == 0 )
	{
     	TextLabel1->setText( Title );
	}
	if ( nLed == 1 )
	{
     	TextLabel2->setText( Title );
	}
	if ( nLed == 2 )
	{
     	TextLabel3->setText( Title );
	}
	if ( nLed == 3 )
	{
     	TextLabel4->setText( Title );
	}
	if ( nLed == 4 )
	{
     	TextLabel5->setText( Title );
	}
	if ( nLed == 5 )
	{
     	TextLabel6->setText( Title );
	}
}

void LEDWindow::SetImage( QString NamePath, int val, int led )
{
	if ( led == 0 )
	{
		if ( val == 0 )
		{		
	   	 	LED1->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED1->setPixmap( *LED1 );
		}
	   if ( val == 1 )
		{
   		 	LED1Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED1Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
	if ( led == 1 )
	{
		if ( val == 0 )
		{		
	   	 	LED2->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED2->setPixmap( *LED2 );
		}
	   if ( val == 1 )
		{
   		 	LED2Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED2Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
	if ( led == 2 )
	{
		if ( val == 0 )
		{		
	   	 	LED3->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED3->setPixmap( *LED3 );
		}
	   if ( val == 1 )
		{
   		 	LED3Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED3Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
	if ( led == 3 )
	{
		if ( val == 0 )
		{		
	   	 	LED4->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED4->setPixmap( *LED4 );
		}
	   if ( val == 1 )
		{
   		 	LED4Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED4Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
	if ( led == 4 )
	{
		if ( val == 0 )
		{		
	   	 	LED5->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED5->setPixmap( *LED5 );
		}
	   if ( val == 1 )
		{
   		 	LED5Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED5Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
	if ( led == 5 )
	{
		if ( val == 0 )
		{		
	   	 	LED6->load( NamePath, NULL, DiffuseAlphaDither );
			PixmapLED6->setPixmap( *LED6 );
		}
	   if ( val == 1 )
		{
   		 	LED6Yellow->load( NamePath, NULL, DiffuseAlphaDither );
		}
 	  	if ( val == 2 )
		{
    		LED6Green->load( NamePath, NULL, DiffuseAlphaDither );
		}
	}
}

void LEDWindow::keyPressEvent ( QKeyEvent *k )
{
    emit KeyPress( k );
}

void LEDWindow::keyReleaseEvent ( QKeyEvent *k )
{
    emit KeyRelease( k );
}

void LEDWindow::SetResizable( bool b )
{
    if ( !b )
    {
        setMinimumSize( size() );
        setMaximumSize( size() );
        //resize( size() );
    }
    else
    {
        setMinimumSize( 774, 160 );
        setMaximumSize( 1300, 250 );
    }
}
