/***************************************************************************
                          ledwindow.h  -  description
                             -------------------
    begin                : Wed Aug 21 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef LEDWINDOW_H
#define LEDWINDOW_H

#include <qvariant.h>
#include <qwidget.h>
#include <qpixmap.h>

#include "eventcue.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QLabel;

class LEDWindow : public QWidget
{ 
    Q_OBJECT

public:
    LEDWindow( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~LEDWindow();

    QFrame* Frame1;
    QLabel* PixmapLED1;
    QLabel* TextLabel1;
    QFrame* Frame2;
    QLabel* PixmapLED2;
    QLabel* TextLabel2;
    QFrame* Frame3;
    QLabel* PixmapLED3;
    QLabel* TextLabel3;
    QFrame* Frame4;
    QLabel* PixmapLED4;
    QLabel* TextLabel4;
    QFrame* Frame5;
    QLabel* PixmapLED5;
    QLabel* TextLabel5;
    QFrame* Frame6;
    QLabel* PixmapLED6;
    QLabel* TextLabel6;

    QPixmap *LED1;
	QPixmap *LED1Yellow;
	QPixmap *LED1Green;

    QPixmap *LED2;
	QPixmap *LED2Yellow;
	QPixmap *LED2Green;

    QPixmap *LED3;
	QPixmap *LED3Yellow;
	QPixmap *LED3Green;

    QPixmap *LED4;
	QPixmap *LED4Yellow;
	QPixmap *LED4Green;

    QPixmap *LED5;
	QPixmap *LED5Yellow;
	QPixmap *LED5Green;

    QPixmap *LED6;
	QPixmap *LED6Yellow;
	QPixmap *LED6Green;

    eventCue *cue[6];
    long Timer[6];
    
	void SetName( int, QString );
	void ResetDisplay();
	int UpdateDisplay( struct eventCue* , long );
	void SetImage( QString, int, int ); //int is type of image and second int led number
    void InternalUpdate();

protected:
    QGridLayout* LEDWindowLayout;
    QGridLayout* Frame1Layout;
    QGridLayout* Frame2Layout;
    QGridLayout* Frame3Layout;
    QGridLayout* Frame4Layout;
    QGridLayout* Frame5Layout;
    QGridLayout* Frame6Layout;

	void UpdateLED( int, int );  //no of light, status (0 off, 1 yellow, 2 green)
	void ResetLED( int );

	int timer1;
	int timer2;
	int timer3;
	int timer4;
	int timer5;
	int timer6;

	int LightStatus[6];
	int Status[6];

	bool event( QEvent* );

    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );

signals:
	void Closed( int );
    void KeyPress( QKeyEvent* );
    void KeyRelease( QKeyEvent* );
public slots:
    void SetResizable( bool );
};

#endif // LEDWINDOW_H
