/***************************************************************************
                          rtmix-network.h  -  description
                             -------------------
    begin                : Sat Sep 14 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

void RTMix::ResetRow()
{
	ExternalClientsTableSelected = -1;
}

QString RTMix::ParseNetEvent( struct eventCue *e )
{
	QString result, tmp;

	result = "E:" + e->event + "<|>" + e->killEvent + "<|>" + e->text + "<|>" + e->say + "<|>" + tmp.setNum( e->ID, 10 ) + "<|>";
	result = result + tmp.setNum( e->time, 10 ) + "<|>";
	result = result + tmp.setNum( e->countdown, 10 ) + "<|>";
	result = result + tmp.setNum( e->absat, 10 ) + "<|>";
	result = result + tmp.setNum( e->happen, 10 ) + "<|>";
	result = result + tmp.setNum( e->chance, 10 ) + "<|>" + e->color + "<|>";
	result = result + tmp.setNum( e->light, 10 ) + "<|>";
	result = result + tmp.setNum( e->blinkSpeed, 10 ) + "<|>";
	result = result + tmp.setNum( e->prepLength, 10 ) + "<|>";
	result = result + tmp.setNum( e->lightLength, 10 ) + "<|>";
	result = result + "-2<|>" + tmp.setNum( e->bpm, 10 ) + "<|>";
	result = result + tmp.setNum( e->type, 10 ) + "<|>" + e->var + "<|>";
	result = result + tmp.setNum( e->method, 10 ) + "<|>";
	result = result + tmp.setNum( e->amt ) + "<|>" + e->accel + "\n";
	//qDebug ( result );
	return result;
}

void RTMix::RemoveExternalClientSelection( int r, int c )
{
	if ( r != ExternalClientsTableSelected )
	{
		SelectExternalClient( r, c );
	}
	else
	{
     	ExternalClientsTable->setCurrentCell( r, -1 );
	}
}

void RTMix::SelectExternalClient( int r, int c )
{
	ExternalClientsTable->clearSelection( TRUE );
	ExternalClientsTable->setCurrentCell( r, -1 );
	QTableSelection sel;
	//sel.init( r, 0 );
	//sel.expandTo( r, 4 );
	ExternalClientsTable->addSelection( sel );
	ExternalClientsTableSelected = r;
}

void RTMix::PurgeNetwork()
{
	int r, c;
	ToggleNetwork( -2, FALSE ); //stop localhost
	for ( r = 0; r < MAXNET; r++ )
	{
		if ( ExternalClientsTable->text( r, 0 ) != "" )
		{
         	for ( c = 0; c < 4; c++ )
			{
             	ExternalClientsTable->setText( r, c, "" );
			}
			if ( net[r] != NULL )
			{
				delete net[r];
				net[r] = NULL;
			}
		}
	}
	if ( socket != 9900 )
	{
		if  ( local != NULL )
		{
         	delete local;
		}
		//local = new SimpleServer( this, this, 9900 );
	}
	socket = 9900;
	Socket->setText( "9900" );
}

void RTMix::ToggleNetwork( int i, const bool b )
{
	QString tmp;
    bool NetFlag;
    int j;

	if ( i == -2 )
	{
		if ( !b )
		{
          T->ToggleMNetHost( FALSE );
			HostingActive = false;
			Error ( " ++ Stopping local socket...\n" );
			if ( local != NULL )
			{
				delete local;
				local = NULL;
			}
			Status->setText( "OFF" );
		}
		else
		{
          T->ToggleMNetHost( TRUE );
			HostingActive = true;
			Error ( " ++ Starting local socket...\n" );
			if ( local == NULL )
			{
				local = new SimpleServer( this, 0, socket );
			}
			//Status->setText( "ON" );
		}
	}
	if ( i == -1 )
	{
		if ( !b )
		{
          T->ToggleMNet( FALSE );
			NetActive = false;
			Error ( " ++ Stopping all connections...\n" );
		}
		else
		{
           //T->ToggleMNet( TRUE );
			NetActive = true;
			Error ( " ++ Starting all connections...\n" );
		}
		for ( int n = 0; n < MAXNET; n++ )
		{
			if ( net[n] != NULL && net[n]->Status > 0 )
			{
				if ( !b )
				{
             		//ExternalClientsTable->setText( n, 2, "OFF" );
					net[n]->closeConnection();
				}
			}
			if ( net[n] != NULL && net[n]->Status < 2 )
			{
				if ( b )
				{
             		//ExternalClientsTable->setText( n, 2, "ON" );
					net[n]->createConnection();
				}
			}
		}
	}
	if ( i >= 0 )
	{
      if (net[i] != NULL)
      {
    		//qDebug( "->%i", net[i]->Status );
    		if ( net[i]->Status > 0 && !b )
    		{
             	//ExternalClientsTable->setText( i, 2, "OFF" );
    			NetActive = false;
    			Error ( " ++ Stopping network connection no." + tmp.setNum( i, 10 ) + "...\n" );
    			net[i]->closeConnection();
              NetFlag = false;
              for ( j = 0; j < MAXNET; j++ )
              {
                  if ( net[i] != NULL && net[i]->Status > 0 )
                  {
                      NetFlag = true;
                  }
              }
              if ( !NetFlag )
              {
                  NetActive = false;
                  T->ToggleMNet( FALSE );
              }
    		}
    		else if ( net[i]->Status < 2 && b )
        	{
              NetActive = true;
        		//ExternalClientsTable->setText( i, 2, "ON" );
              T->ToggleMNet( TRUE );
        		Error ( " ++ Starting network connection no." + tmp.setNum( i, 10 ) + "...\n" );
        		net[i]->createConnection();
        	}
      }
      else
      {
          Error ( " -- Error: network connection no. " + tmp.setNum( i, 10 ) + " cannot be started since it has not been initialized..." );
      }  
    }
}

void RTMix::SendGlobal( QString s )
{
	//qDebug( "%i", NetActive );
	if ( NetActive )
	{
		//qDebug( "yes" );
      LastSent = s;
      //LastSentTime = A->GetTimeCount();
       T->ToggleANetO( TRUE );
		for ( int list = 0; list < MAXNET; list++ )
		{
			if ( net[list] != NULL && net[list]->Status == 2 )
			{
				//qDebug( "%i", list );
				net[list]->sendStringToServer( s );
			}
		}
	}	
}

void RTMix::SendSingle( QString s, int n )
{
    if ( n == -1 )
    {
        SendGlobal( s );
    }    
	else if ( NetActive )
	{
       T->ToggleANetO( TRUE );
 		if ( net[n] != NULL && net[n]->Status == 2 )
 		{
 			net[n]->sendStringToServer( s );
          LastSent = s;
		}
        else
        {
          Error( " -- Error: requested client is not connected... Ignoring the networked event.\n" );
        }
	}
}

void RTMix::SendGlobalEvent( struct eventCue *e )
{
    QString s;

    if ( NetActive )
	{
       T->ToggleANetO( TRUE );
       //LastSent = net;
        s = ParseNetEvent( e );
               
		for ( int list = 0; list < MAXNET; list++ )
		{
			
            if ( net[list] != NULL && net[list]->Status == 2 )
			{
             	net[list]->sendStringToServer( s );
			}
		}
	}
}

void RTMix::SendSingleEvent( struct eventCue *e )
{
    QString s;
  
	if ( NetActive )
	{
		if ( net[e->netAddress] != NULL && net[e->netAddress]->Status == 2 )
		{
             s = ParseNetEvent( e );
             net[e->netAddress]->sendStringToServer( s );
             //LastSent = s;
             T->ToggleANetO( TRUE );
		}
        else
        {
          Error( " -- Error: requested client is not connected... Ignoring the networked event.\n" );
        }
	}
}

void RTMix::StopSelectedClient()
{
	if ( ExternalClientsTableSelected >= 0 )
	{
		ToggleNetwork( ExternalClientsTableSelected, FALSE );
	}
}

void RTMix::StartSelectedClient()
{
	if ( ExternalClientsTableSelected >= 0 )
	{
		ToggleNetwork( ExternalClientsTableSelected, TRUE );
	}
}

void RTMix::StopAllClients()
{
	ToggleNetwork( -1, FALSE );
}

void RTMix::StartAllClients()
{
	ToggleNetwork( -1, TRUE );
}

void RTMix::StopHost()
{
	ToggleNetwork( -2, FALSE );
}

void RTMix::StartHost()
{
	ToggleNetwork( -2, TRUE );
}

void RTMix::UpdateNetStatus( int r, QString s )
{
	if ( r == -1 )
	{
		Status->setText( s );
	}
	else
    {
		ExternalClientsTable->setText( r, 2, s );
	}
}

void RTMix::ChangeLocalSocket( int n )
{
 	if ( n != socket )
	{
		QString tmp;
		socket = n;
		if ( local != NULL )
		{
     		delete local;
			local = NULL;
		}
		//local = new SimpleServer( this, this, socket );
		//connect( local, SIGNAL ( newConnect( QString ) ), this, SLOT ( UpdateHostStatus( QString ) ) );
		Socket->setText( tmp.setNum( socket, 10) );
	}
}

void RTMix::UpdateHostStatus( QString s )
{
	Status->setText( s ); 	
}

QString RTMix::GetNetAuth()
{
    return S->GetNetAuth();
}
