/***************************************************************************
                          rtmix.cpp  -  description
                             -------------------
    begin                : Thu Nov 13 2001
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <qstring.h>
#include <qframe.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qmovie.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qtextstream.h>
#include <qlcdnumber.h>
#include <qaccel.h>
#include <qapplication.h>
#include <qtable.h>
#include <qprogressbar.h>
#include <qtimer.h>

#include "rtmix.h"
#include "client.h"
#include "version.h"
#include "QLCD.h"
//#include "tux.h"
#include "settings.h"
#include "QLED.h"
#include "qtabledisplay.h"
#include "simpleserver.h"
#include "qmidi.h"
#include "oscevent.h"
#include "colortableitem.h"
#include "stringevent.h"
#include "midievent.h"
#include "TimerEvent.h"
#include "longevent.h"

/*
 *  Constructs a RTMix which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'
 */
RTMix::RTMix( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
	Sp = new Splash(0, "Splash", WX11BypassWM);
	Sp->show();
	qApp->processEvents();
    qApp->setMainWidget( Sp );

	DefaultTextInterfaceColor = "55FF00";

	imageRewind.load("/usr/local/rtmix/images/rew.xpm", NULL, DiffuseAlphaDither);
	imageFForward.load("/usr/local/rtmix/images/ff.xpm", NULL, DiffuseAlphaDither);
	imageRewindOff.load("/usr/local/rtmix/images/rewoff.xpm", NULL, DiffuseAlphaDither);
	imageFForwardOff.load("/usr/local/rtmix/images/ffoff.xpm", NULL, DiffuseAlphaDither);

	//QPixmap image0( ( const char** ) image0_data );
    QPixmap image1;
	image1.load("/usr/local/rtmix/images/eraser.xpm", NULL, DiffuseAlphaDither);
    QPixmap image2;
	image2.load("/usr/local/rtmix/images/leftedge.xpm", NULL, DiffuseAlphaDither);
    QPixmap image3;
	image3.load("/usr/local/rtmix/images/rightedge.xpm", NULL, DiffuseAlphaDither);
    QPixmap image4;
	image4.load("/usr/local/rtmix/images/pencil.xpm", NULL, DiffuseAlphaDither);
    QPixmap image5;
	image5.load("/usr/local/rtmix/images/extern.xpm", NULL, DiffuseAlphaDither);
    QPixmap image6;
	image6.load("/usr/local/rtmix/images/bottomedge.xpm", NULL, DiffuseAlphaDither);
    QPixmap image7;
	image7.load("/usr/local/rtmix/images/topedge.xpm", NULL, DiffuseAlphaDither);
    QPixmap image8;
	image8.load("/usr/local/rtmix/images/console.xpm", NULL, DiffuseAlphaDither);
    QPixmap image9;
	image9.load("/usr/local/rtmix/images/play.xpm", NULL, DiffuseAlphaDither);
    QPixmap image10;
	image10.load("/usr/local/rtmix/images/pause.xpm", NULL, DiffuseAlphaDither);
    QPixmap image11;
	image11.load("/usr/local/rtmix/images/recycle.xpm", NULL, DiffuseAlphaDither);
    QPixmap image13;
	image13.load("/usr/local/rtmix/images/stop.xpm", NULL, DiffuseAlphaDither);
    QPixmap image14;
	image14.load("/usr/local/rtmix/images/panic.xpm", NULL, DiffuseAlphaDither);
    QPixmap image15;
	image15.load("/usr/local/rtmix/images/size.xpm", NULL, DiffuseAlphaDither);
    QPixmap image16;
	image16.load("/usr/local/rtmix/images/helparrow.xpm", NULL, DiffuseAlphaDither);
    QPixmap image17;
	image17.load("/usr/local/rtmix/images/help.xpm", NULL, DiffuseAlphaDither);
    QPixmap image18;
	image18.load("/usr/local/rtmix/images/quit.xpm", NULL, DiffuseAlphaDither);
    QPixmap image19;
	image19.load("/usr/local/rtmix/images/tux-small.png", NULL, DiffuseAlphaDither);
    
    if ( !name )
	setName( "RTMix" );
    setEnabled( TRUE );
    resize( 770, 768 );
	setMaximumSize( 770, 768 );
	setMinimumSize( 770, 768 );
    setCaption( tr( "RTMix" ) );

    //QPalette pal;
    //QColorGroup cg;

	setFocusPolicy( QWidget::ClickFocus );

    PixmapLogo = new QLabel( this, "PixmapLogo" );
    PixmapLogo->setEnabled( TRUE );
    PixmapLogo->setGeometry( QRect( 726, 10, 34, 41 ) );
    PixmapLogo->setCursor( QCursor( 0 ) );
    PixmapLogo->setLineWidth( 0 );
    PixmapLogo->setPixmap( image19 );
    PixmapLogo->setScaledContents( TRUE );
    //QToolTip::add(  PixmapLogo, tr( "Tux Logo" ) );
    QWhatsThis::add(  PixmapLogo, tr( "One, Two, Three... *** ** * *****\n Four, Five, Six... *** ** * *****" ) );

    Separator3 = new QFrame( this, "Separator3" );
    Separator3->setEnabled( FALSE );
    Separator3->setGeometry( QRect( 500, 10, 2, 41 ) );
    Separator3->setFrameStyle( QFrame::VLine | QFrame::Sunken );

    Separator2 = new QFrame( this, "Separator2" );
    Separator2->setEnabled( FALSE );
    Separator2->setGeometry( QRect( 390, 10, 2, 41 ) );
    Separator2->setFrameStyle( QFrame::VLine | QFrame::Sunken );

    Separator1 = new QFrame( this, "Separator1" );
    Separator1->setEnabled( FALSE );
    Separator1->setGeometry( QRect( 270, 10, 2, 41 ) );
    Separator1->setFrameStyle( QFrame::VLine | QFrame::Sunken );

    TimerGroupBox = new QGroupBox( this, "TimerGroupBox" );
    TimerGroupBox->setEnabled( TRUE );
    TimerGroupBox->setGeometry( QRect( 10, 50, 750, 160 ) );
    TimerGroupBox->setTitle( tr( "Main Timer" ) );
	TimerGroupBox->setFocusPolicy( QWidget::ClickFocus );
    TimerGroupBox->setAlignment( int( QGroupBox::AlignHCenter ) );

    NSecond = new QLCD( TimerGroupBox, "NSecond" );
    NSecond->setGeometry( QRect( 415, 20, 65, 110 ) );
    cgTime.setColor( QColorGroup::Foreground, QColor( 85, 255, 0) );
    cgTime.setColor( QColorGroup::Button, QColor( 85, 255, 0) );
    cgTime.setColor( QColorGroup::Light, QColor( 85, 255, 0) );
    cgTime.setColor( QColorGroup::Midlight, QColor( 127, 255, 63) );
    cgTime.setColor( QColorGroup::Dark, QColor( 42, 127, 0) );
    cgTime.setColor( QColorGroup::Mid, QColor( 57, 170, 0) );
    cgTime.setColor( QColorGroup::Text, white );
    cgTime.setColor( QColorGroup::BrightText, white );
    cgTime.setColor( QColorGroup::ButtonText, white );
    cgTime.setColor( QColorGroup::Base, black );
    cgTime.setColor( QColorGroup::Background, black );
    cgTime.setColor( QColorGroup::Shadow, black );
    cgTime.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cgTime.setColor( QColorGroup::HighlightedText, white );
    palTime.setActive( cgTime );
    palTime.setInactive( cgTime );
    palTime.setDisabled( cgTime );
    NSecond->setPalette( palTime );
    NSecond->setCursor( QCursor( 5 ) );
    NSecond->setMouseTracking( FALSE );
    NSecond->setFocusPolicy( QLCD::NoFocus );
    NSecond->setAcceptDrops( FALSE );
    NSecond->setAutoMask( FALSE );
    NSecond->setFrameShape( QLCD::NoFrame );
    NSecond->setFrameShadow( QLCD::Plain );
    NSecond->setLineWidth( 2 );
    NSecond->setMargin( 0 );
    NSecond->setMidLineWidth( 0 );
    NSecond->setSmallDecimalPoint( FALSE );
    NSecond->setNumDigits( 1 );
    NSecond->setSegmentStyle( QLCD::Filled );
    NSecond->setProperty( "intValue", 0 );

    NTenSecond = new QLCD( TimerGroupBox, "NTenSecond" );
    NTenSecond->setGeometry( QRect( 350, 20, 65, 110 ) );
    NTenSecond->setPalette( palTime );
    NTenSecond->setCursor( QCursor( 5 ) );
    NTenSecond->setMouseTracking( FALSE );
    NTenSecond->setFocusPolicy( QLCD::NoFocus );
    NTenSecond->setAcceptDrops( FALSE );
    NTenSecond->setAutoMask( FALSE );
    NTenSecond->setFrameShape( QLCD::NoFrame );
    NTenSecond->setFrameShadow( QLCD::Plain );
    NTenSecond->setLineWidth( 2 );
    NTenSecond->setMargin( 0 );
    NTenSecond->setMidLineWidth( 0 );
    NTenSecond->setSmallDecimalPoint( FALSE );
    NTenSecond->setNumDigits( 1 );
    NTenSecond->setSegmentStyle( QLCD::Filled );
    NTenSecond->setProperty( "intValue", 0 );

    PlayIndicator = new QLED( TimerGroupBox, "PlayIndicator" );
    PlayIndicator->setGeometry( QRect( 630, 20, 110, 110 ) );
    PlayIndicator->setLineWidth( 0 );
    //PlayIndicator->setPixmap( imageRedoff );
    PlayIndicator->setScaledContents( TRUE );
    QToolTip::add(  PlayIndicator, tr( "Play indicator" ) );

    PlayIndicatorLabel = new QLabel( TimerGroupBox, "PlayIndicatorLabel" );
    PlayIndicatorLabel->setGeometry( QRect( 631, 130, 110, 21 ) );
    PlayIndicatorLabel->setText( tr( "Play Indicator" ) );
    PlayIndicatorLabel->setAlignment( int( QLabel::AlignCenter ) );

    SecondsLabel = new QLabel( TimerGroupBox, "SecondsLabel" );
    SecondsLabel->setGeometry( QRect( 360, 130, 110, 21 ) );
    SecondsLabel->setText( tr( "Seconds" ) );
    SecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    MinutesLabel = new QLabel( TimerGroupBox, "MinutesLabel" );
    MinutesLabel->setGeometry( QRect( 190, 130, 110, 21 ) );
    MinutesLabel->setText( tr( "Minutes" ) );
    MinutesLabel->setAlignment( int( QLabel::AlignCenter ) );

    HoursLabel = new QLabel( TimerGroupBox, "HoursLabel" );
    HoursLabel->setGeometry( QRect( 30, 130, 100, 21 ) );
    HoursLabel->setText( tr( "Hours" ) );
    HoursLabel->setAlignment( int( QLabel::AlignCenter ) );

    DecisecondsLabel = new QLabel( TimerGroupBox, "DecisecondsLabel" );
    DecisecondsLabel->setGeometry( QRect( 520, 130, 80, 21 ) );
    DecisecondsLabel->setText( tr( "Centiseconds" ) );
    DecisecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    NCentisecond = new QLCD( TimerGroupBox, "NCentisecond" );
    NCentisecond->setGeometry( QRect( 560, 20, 50, 110 ) );
    NCentisecond->setPalette( palTime );
    NCentisecond->setCursor( QCursor( 5 ) );
    NCentisecond->setMouseTracking( FALSE );
    NCentisecond->setFocusPolicy( QLCD::NoFocus );
    NCentisecond->setAcceptDrops( FALSE );
    NCentisecond->setAutoMask( FALSE );
    NCentisecond->setFrameShape( QLCD::NoFrame );
    NCentisecond->setFrameShadow( QLCD::Plain );
    NCentisecond->setLineWidth( 1 );
    NCentisecond->setMargin( 0 );
    NCentisecond->setMidLineWidth( 0 );
    NCentisecond->setSmallDecimalPoint( FALSE );
    NCentisecond->setNumDigits( 1 );
    NCentisecond->setMode( QLCD::DEC );
    NCentisecond->setSegmentStyle( QLCD::Filled );
    NCentisecond->setProperty( "intValue", 0 );

    NTenCentisecond = new QLCD( TimerGroupBox, "NTenCentisecond" );
    NTenCentisecond->setGeometry( QRect( 510, 20, 50, 110 ) );
    NTenCentisecond->setPalette( palTime );
    NTenCentisecond->setCursor( QCursor( 5 ) );
    NTenCentisecond->setMouseTracking( FALSE );
    NTenCentisecond->setFocusPolicy( QLCD::NoFocus );
    NTenCentisecond->setAcceptDrops( FALSE );
    NTenCentisecond->setAutoMask( FALSE );
    NTenCentisecond->setFrameShape( QLCD::NoFrame );
    NTenCentisecond->setFrameShadow( QLCD::Plain );
    NTenCentisecond->setLineWidth( 1 );
    NTenCentisecond->setMargin( 0 );
    NTenCentisecond->setMidLineWidth( 0 );
    NTenCentisecond->setSmallDecimalPoint( FALSE );
    NTenCentisecond->setNumDigits( 1 );
    NTenCentisecond->setMode( QLCD::DEC );
    NTenCentisecond->setSegmentStyle( QLCD::Filled );
    NTenCentisecond->setProperty( "intValue", 0 );

    TimerLeftEdge = new QLabel( TimerGroupBox, "TimerLeftEdge" );
    TimerLeftEdge->setGeometry( QRect( 10, 20, 10, 110 ) );
    TimerLeftEdge->setPixmap( image2 );
    TimerLeftEdge->setScaledContents( TRUE );

    TimerRightEdge = new QLabel( TimerGroupBox, "TimerRightEdge" );
    TimerRightEdge->setEnabled( TRUE );
    TimerRightEdge->setGeometry( QRect( 610, 20, 10, 110 ) );
    TimerRightEdge->setPixmap( image3 );
    TimerRightEdge->setScaledContents( TRUE );

    NHour = new QLCD( TimerGroupBox, "NHour" );
    NHour->setGeometry( QRect( 20, 20, 120, 110 ) );
    NHour->setPalette( palTime );
    NHour->setCursor( QCursor( 5 ) );
    NHour->setMouseTracking( FALSE );
    NHour->setFocusPolicy( QLCDNumber::NoFocus );
    NHour->setAcceptDrops( FALSE );
    NHour->setAutoMask( FALSE );
    NHour->setFrameShape( QLCDNumber::NoFrame );
    NHour->setFrameShadow( QLCDNumber::Plain );
    NHour->setLineWidth( 2 );
    NHour->setMargin( 0 );
    NHour->setMidLineWidth( 0 );
    NHour->setSmallDecimalPoint( FALSE );
    NHour->setNumDigits( 2 );
    NHour->setSegmentStyle( QLCD::Filled );
    NHour->setProperty( "intValue", 0 );

    NMinute = new QLCD( TimerGroupBox, "NMinute" );
    NMinute->setGeometry( QRect( 245, 20, 65, 110 ) );
    NMinute->setPalette( palTime );
    NMinute->setCursor( QCursor( 5 ) );
    NMinute->setMouseTracking( FALSE );
    NMinute->setFocusPolicy( QLCD::NoFocus );
    NMinute->setAcceptDrops( FALSE );
    NMinute->setAutoMask( FALSE );
    NMinute->setFrameShape( QLCD::NoFrame );
    NMinute->setFrameShadow( QLCD::Plain );
    NMinute->setLineWidth( 2 );
    NMinute->setMargin( 0 );
    NMinute->setMidLineWidth( 0 );
    NMinute->setSmallDecimalPoint( FALSE );
    NMinute->setNumDigits( 1 );
    NMinute->setSegmentStyle( QLCD::Filled );
    NMinute->setProperty( "intValue", 0 );

    NTenMinute = new QLCD( TimerGroupBox, "NTenMinute" );
    NTenMinute->setGeometry( QRect( 180, 20, 65, 110 ) );
    NTenMinute->setPalette( palTime );
    NTenMinute->setCursor( QCursor( 5 ) );
    NTenMinute->setMouseTracking( FALSE );
    NTenMinute->setFocusPolicy( QLCD::NoFocus );
    NTenMinute->setAcceptDrops( FALSE );
    NTenMinute->setAutoMask( FALSE );
    NTenMinute->setFrameShape( QLCD::NoFrame );
    NTenMinute->setFrameShadow( QLCD::Plain );
    NTenMinute->setLineWidth( 2 );
    NTenMinute->setMargin( 0 );
    NTenMinute->setMidLineWidth( 0 );
    NTenMinute->setSmallDecimalPoint( FALSE );
    NTenMinute->setNumDigits( 1 );
    NTenMinute->setSegmentStyle( QLCD::Filled );
    NTenMinute->setProperty( "intValue", 0 );

	HourMinuteColumn = new QLCDNumber( TimerGroupBox, "HourMinuteColumn");
    HourMinuteColumn->setGeometry( QRect( 140, 20, 40, 110 ) );
    HourMinuteColumn->setPalette( palTime );
    HourMinuteColumn->setCursor( QCursor( 0 ) );
    HourMinuteColumn->setMouseTracking( FALSE );
    HourMinuteColumn->setFocusPolicy( QLCDNumber::NoFocus );
    HourMinuteColumn->setAcceptDrops( FALSE );
    HourMinuteColumn->setAutoMask( FALSE );
    HourMinuteColumn->setFrameShape( QLCDNumber::NoFrame );
    HourMinuteColumn->setFrameShadow( QLCDNumber::Plain );
    HourMinuteColumn->setLineWidth( 2 );
    HourMinuteColumn->setMargin( 0 );
    HourMinuteColumn->setMidLineWidth( 0 );
    HourMinuteColumn->setSmallDecimalPoint( FALSE );
    HourMinuteColumn->setNumDigits( 1 );
    HourMinuteColumn->setMode( QLCDNumber::DEC );
    HourMinuteColumn->setSegmentStyle( QLCDNumber::Filled );
	HourMinuteColumn->display( ":" );

    MinuteSecondColumn = new QLCDNumber( TimerGroupBox, "MinuteSecondColumn" );
    MinuteSecondColumn->setGeometry( QRect( 310, 20, 40, 110 ) );
    MinuteSecondColumn->setPalette( palTime );
    MinuteSecondColumn->setCursor( QCursor( 0 ) );
    MinuteSecondColumn->setMouseTracking( FALSE );
    MinuteSecondColumn->setFocusPolicy( QLCDNumber::NoFocus );
    MinuteSecondColumn->setAcceptDrops( FALSE );
    MinuteSecondColumn->setAutoMask( FALSE );
    MinuteSecondColumn->setFrameShape( QLCDNumber::NoFrame );
    MinuteSecondColumn->setFrameShadow( QLCDNumber::Plain );
    MinuteSecondColumn->setLineWidth( 2 );
    MinuteSecondColumn->setMargin( 0 );
    MinuteSecondColumn->setMidLineWidth( 0 );
    MinuteSecondColumn->setSmallDecimalPoint( FALSE );
    MinuteSecondColumn->setNumDigits( 1 );
    MinuteSecondColumn->setMode( QLCDNumber::DEC );
    MinuteSecondColumn->setSegmentStyle( QLCDNumber::Filled );
	MinuteSecondColumn->display( ":" );

    SecondCentisecondDot = new QLCDNumber( TimerGroupBox, "SecondCentisecondDot" );
    SecondCentisecondDot->setGeometry( QRect( 480, 20, 30, 110 ) );	
    SecondCentisecondDot->setPalette( palTime );
    SecondCentisecondDot->setCursor( QCursor( 0 ) );
    SecondCentisecondDot->setMouseTracking( FALSE );
    SecondCentisecondDot->setFocusPolicy( QLCDNumber::NoFocus );
    SecondCentisecondDot->setAcceptDrops( FALSE );
    SecondCentisecondDot->setAutoMask( FALSE );
    SecondCentisecondDot->setFrameShape( QLCDNumber::NoFrame );
    SecondCentisecondDot->setFrameShadow( QLCDNumber::Plain );
    SecondCentisecondDot->setLineWidth( 2 );
    SecondCentisecondDot->setMargin( 0 );
    SecondCentisecondDot->setMidLineWidth( 0 );
    SecondCentisecondDot->setSmallDecimalPoint( FALSE );
    SecondCentisecondDot->setNumDigits( 1 );
    SecondCentisecondDot->setMode( QLCDNumber::DEC );
    SecondCentisecondDot->setSegmentStyle( QLCDNumber::Filled );
    SecondCentisecondDot->display( "." );

    Tabs = new QTabWidget( this, "Tabs" );
    Tabs->setGeometry( QRect( 10, 380, 750, 380 ) );
    Tabs->setTabPosition( QTabWidget::Top );
    Tabs->setTabShape( QTabWidget::Rounded );
    Tabs->setFocusPolicy( QWidget::StrongFocus );
    QWhatsThis::add(  Tabs, tr( "You can cycle between the five available tabs by using ALT+1 - ALT+4 keys." ) );

    PlayTab = new QWidget( Tabs, "PlayTab" );
    PlayTab->setFocusPolicy( QWidget::ClickFocus );

    TextLabel2 = new QLabel( PlayTab, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 280, 2, 180, 16 ) );
    TextLabel2->setText( tr( "Notification Interface" ) );
    TextLabel2->setAlignment( int( QLabel::AlignCenter ) );

    NotificationBottomEdge = new QLabel( PlayTab, "NotificationBottomEdge" );
    NotificationBottomEdge->setGeometry( QRect( 10, 330, 728, 12 ) );
    NotificationBottomEdge->setPixmap( image6 );
    NotificationBottomEdge->setScaledContents( TRUE );

    NotificationTopEdge = new QLabel( PlayTab, "NotificationTopEdge" );
    NotificationTopEdge->setGeometry( QRect( 10, 18, 728, 10 ) );
    NotificationTopEdge->setPixmap( image7 );
    NotificationTopEdge->setScaledContents( TRUE );

    TextInterface = new QTextBrowser( PlayTab, "TextInterface" );
    //TextInterface->setEnabled( TRUE );
    TextInterface->setGeometry( QRect( 10, 28, 728, 302 ) );
    cgText.setColor( QColorGroup::Foreground, QColor( 127, 127, 127) );
    cgText.setColor( QColorGroup::Button, QColor( 239, 239, 239) );
    cgText.setColor( QColorGroup::Light, white );
    cgText.setColor( QColorGroup::Midlight, QColor( 247, 247, 247) );
    cgText.setColor( QColorGroup::Dark, QColor( 119, 119, 119) );
    cgText.setColor( QColorGroup::Mid, QColor( 159, 159, 159) );
    cgText.setColor( QColorGroup::Text, QColor( 85, 255, 0) );
    cgText.setColor( QColorGroup::BrightText, white );
    cgText.setColor( QColorGroup::ButtonText, black );
    cgText.setColor( QColorGroup::Base, black );
    cgText.setBrush( QColorGroup::Background, QBrush( white, NULL ) );
    cgText.setColor( QColorGroup::Shadow, black );
    cgText.setColor( QColorGroup::Highlight, QColor( 152, 167, 201) );
    cgText.setColor( QColorGroup::HighlightedText, white );
    palText.setActive( cgText );
    palText.setInactive( cgText );
    palText.setDisabled( cgText );
    TextInterface->setPalette( palText );
    TextInterface->setFocusPolicy( QTextBrowser::NoFocus );
    TextInterface->setAcceptDrops( FALSE );
    TextInterface->setFrameShape( QTextBrowser::Panel );
    TextInterface->setFrameShadow( QTextBrowser::Plain );
    TextInterface->setLineWidth( 0 );
    TextInterface->setCursor( QCursor( 0 ) );
    TextInterface->setText( tr( "" ) );
    TextInterface->setVScrollBarMode( QTextBrowser::AlwaysOff );
    TextInterface->setHScrollBarMode( QTextBrowser::AlwaysOff );
    TextInterface->setWordWrap( QTextBrowser::WidgetWidth );
    QToolTip::add(  TextInterface, tr( "Notification Interface Window" ) );
    QWhatsThis::add(  TextInterface, tr( "This window displays event-assigned text" ) );
    Tabs->insertTab( PlayTab, tr( "Playback" ) );

    tab = new QWidget( Tabs, "tab" );
    tab->setFocusPolicy( QWidget::ClickFocus );

    SaveAsButton = new QPushButton( tab, "SaveAsButton" );
    SaveAsButton->setGeometry( QRect( 250, 310, 70, 30 ) );
    SaveAsButton->setText( tr( "Save As" ) );
    //SaveAsButton->setAccel( CTRL + Key_A );
    SaveAsButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  SaveAsButton, tr( "Save scriptfile under a new filename" ) );
    QWhatsThis::add(  SaveAsButton, tr( "Save the scriptfile under a new filename" ) );




    PurgeButton = new QPushButton( tab, "PurgeButton" );
    PurgeButton->setGeometry( QRect( 345, 310, 30, 30 ) );
    PurgeButton->setPixmap( image1 );
    PurgeButton->setAccel( CTRL + Key_Delete );
    PurgeButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  PurgeButton, tr( "Purge Console (Ctrl+Del)" ) );
    QWhatsThis::add(  PurgeButton, tr( "Purge Console, thus rendering it completely empty." ) );

    GoToButton = new QPushButton( tab, "GoToErrorButton" );
    GoToButton->setGeometry( QRect( 385, 310, 30, 30 ) );
    GoToButton->setPixmap( image5 );
    GoToButton->setAccel( CTRL + Key_G );
    GoToButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  GoToButton, tr( "Go to error (Ctrl+G)" ) );
    QWhatsThis::add(  GoToButton, tr( "Go to line in your scriptfile where error is located (as described by your console)." ) );

    ErrorButton = new QPushButton( tab, "ConsoleButton" );
    ErrorButton->setGeometry( QRect( 425, 310, 30, 30 ) );
    ErrorButton->setPixmap( image8 );
    ErrorButton->setAccel( CTRL + Key_E );
    ErrorButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  ErrorButton, tr( "Restore Console (Ctrl+E)" ) );
    QWhatsThis::add(  ErrorButton, tr( "Restore Console and bring it to front (make it easily visible)." ) );
            
    RefreshButton = new QPushButton( tab, "RefreshButton" );
    RefreshButton->setGeometry( QRect( 465, 310, 30, 30 ) );
    RefreshButton->setPixmap( image11 );
    RefreshButton->setAccel( CTRL + Key_R );
    RefreshButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  RefreshButton, tr( "Refresh Editor contents(Ctrl+R)" ) );
    QWhatsThis::add(  RefreshButton, tr( "Synchronize Editor window with the saved scriptfile (if the scriptfile was altered using external editor)." ) );

    EditButton = new QPushButton( tab, "EditButton" );
    EditButton->setGeometry( QRect( 505, 310, 30, 30 ) );
    EditButton->setPixmap( image4 );
    EditButton->setAccel( CTRL + Key_W );
    EditButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  EditButton, tr( "External Editor (Ctrl+W)" ) );
    QWhatsThis::add(  EditButton, tr( "Edit scriptfile using external editor." ) );

    EditorLineNumber = new QLabel( tab, "EditorLine" );
    EditorLineNumber->setGeometry( QRect( 560, 314, 50, 22 ) );
    //EditorLineNumber->setFocusPolicy( QWidget::NoFocus );
    //EditorLineNumber->setReadOnly( TRUE );
    EditorLineNumber->setFrameShape( QLabel::StyledPanel );
    EditorLineNumber->setFrameShadow( QLabel::Sunken );
    EditorLineNumber->setAlignment( Qt::AlignRight | Qt::AlignVCenter );
    EditorLineNumber->setText( "0" );
    QToolTip::add(  EditorLineNumber, tr( "Editor's cursor line position." ) );
    QWhatsThis::add(  EditorLineNumber, tr( "Shows line number on which the editor's cursor is located." ) );    





    NewButton = new QPushButton( tab, "NewButton" );
    NewButton->setGeometry( QRect( 10, 310, 70, 30 ) );
    NewButton->setText( tr( "New" ) );
	NewButton->setAccel( CTRL + Key_N );
	NewButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  NewButton, tr( "Create new scriptfile (Ctrl+N)" ) );
    QWhatsThis::add(  NewButton, tr( "Wipe the text interface clean and create a new scriptfile." ) );

    SaveButton = new QPushButton( tab, "SaveButton" );
    SaveButton->setGeometry( QRect( 170, 310, 70, 30 ) );
    SaveButton->setText( tr( "Save" ) );
	SaveButton->setAccel( CTRL + Key_S );
	SaveButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  SaveButton, tr( "Save event scriptfile (Ctrl+S)" ) );
    QWhatsThis::add(  SaveButton, tr( "Quickly save the scriptfile." ) );

    OpenButton = new QPushButton( tab, "OpenButton" );
    OpenButton->setGeometry( QRect( 90, 310, 70, 30 ) );
    OpenButton->setText( tr( "Open" ) );
	OpenButton->setAccel( CTRL + Key_O );
	OpenButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  OpenButton, tr( "Open scriptfile (Ctrl+O)" ) );
	QWhatsThis::add(  OpenButton, tr( "Open a new scriptfile." ) );
    /*
    ErrorLogLabel = new QLabel( tab, "ErrorLogLabel" );
    ErrorLogLabel->setGeometry( QRect( 290, 200, 151, 16 ) );
    ErrorLogLabel->setText( tr( "Console" ) );
    ErrorLogLabel->setAlignment( int( QLabel::AlignCenter ) );
    */
    EditWindowLabel = new QLabel( tab, "EditWindowLabel" );
    EditWindowLabel->setGeometry( QRect( 280, 2, 180, 16 ) );
    EditWindowLabel->setText( tr( "Edit Window" ) );
    EditWindowLabel->setAlignment( int( QLabel::AlignCenter ) );

    CompileButton = new QPushButton( tab, "CompileButton" );
    CompileButton->setGeometry( QRect( 640, 310, 98, 30 ) );
    CompileButton->setText( tr( "COMPILE" ) );
    CompileButton->setAccel( CTRL + Key_M );
    CompileButton->setDefault( FALSE );
    CompileButton->setFlat( FALSE );
    CompileButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  CompileButton, tr( "Compile currently loaded event scriptfile (Ctrl+M)" ) );
    QWhatsThis::add(  CompileButton, tr( "Compile currently loaded scriptfile and check for errors (this is done automatically when you press PLAY button if the scriptfile has not been already compiled)" ) );
    /*
    ErrorLog = new QTextBrowser( tab, "Console" );
    ErrorLog->setEnabled( TRUE );
    ErrorLog->setGeometry( QRect( 10, 220, 728, 80 ) );
    cgError.setColor( QColorGroup::Foreground, QColor( 127, 127, 127) );
    cgError.setColor( QColorGroup::Button, QColor( 239, 239, 239) );
    cgError.setColor( QColorGroup::Light, white );
    cgError.setColor( QColorGroup::Midlight, QColor( 247, 247, 247) );
    cgError.setColor( QColorGroup::Dark, QColor( 119, 119, 119) );
    cgError.setColor( QColorGroup::Mid, QColor( 159, 159, 159) );
    cgError.setColor( QColorGroup::Text, QColor( 255, 255, 255) );
    cgError.setColor( QColorGroup::BrightText, white );
    cgError.setColor( QColorGroup::ButtonText, black );
    cgError.setColor( QColorGroup::Base, black );
    cgError.setBrush( QColorGroup::Background, QBrush( white, NULL ) );
    cgError.setColor( QColorGroup::Shadow, black );
    cgError.setColor( QColorGroup::Highlight, QColor( 152, 167, 201) );
    cgError.setColor( QColorGroup::HighlightedText, white );
    palError.setActive( cgError );
    palError.setInactive( cgError );
    palError.setDisabled( cgError );
    ErrorLog->setPalette( palError );
    ErrorLog->setFocusPolicy( QTextBrowser::NoFocus );
    ErrorLog->setAcceptDrops( FALSE );
    ErrorLog->setFrameShape( QTextBrowser::Panel );
    ErrorLog->setLineWidth( 2 );
    ErrorLog->setWordWrap( QTextBrowser::WidgetWidth );
    ErrorLog->setUndoRedoEnabled( FALSE );
    ErrorLog->setUndoDepth( 0 );
    ErrorLog->setReadOnly(TRUE);
    //ErrorLog->setTextFormat(RichText);
    QToolTip::add(  ErrorLog, tr( "Console Window" ) );
    QWhatsThis::add(  ErrorLog, tr( "Console shows different compile-time and run-time messages, including errors, warnings, and notifications." ) );
    */
    Editor = new QTextEdit( tab, "Editor" );
    Editor->setGeometry( QRect( 10, 20, 728, 280 ) );
    cgEdit.setColor( QColorGroup::Foreground, QColor( 127, 127, 127) );
    cgEdit.setColor( QColorGroup::Button, QColor( 239, 239, 239) );
    cgEdit.setColor( QColorGroup::Light, white );
    cgEdit.setColor( QColorGroup::Midlight, QColor( 247, 247, 247) );
    cgEdit.setColor( QColorGroup::Dark, QColor( 119, 119, 119) );
    cgEdit.setColor( QColorGroup::Mid, QColor( 159, 159, 159) );
    cgEdit.setColor( QColorGroup::Text, QColor( 85, 255, 0) );
    cgEdit.setColor( QColorGroup::BrightText, white );
    cgEdit.setColor( QColorGroup::ButtonText, black );
    cgEdit.setColor( QColorGroup::Base, black );
    cgEdit.setBrush( QColorGroup::Background, QBrush( white, NULL ) );
    cgEdit.setColor( QColorGroup::Shadow, black );
    cgEdit.setColor( QColorGroup::Highlight, QColor( 152, 167, 201) );
    cgEdit.setColor( QColorGroup::HighlightedText, white );
    palEdit.setActive( cgEdit );
    palEdit.setInactive( cgEdit );
    palEdit.setDisabled( cgEdit );
    Editor->setPalette( palEdit );
    //Editor->setCursor( QCursor( 4 ) );
    Editor->setFrameShape( QTextEdit::Panel );
    Editor->setLineWidth( 2 );
    Editor->setUndoDepth( 50 );
    Editor->setFocusPolicy( QWidget::ClickFocus );
    Editor->setText( tr( "" ) );
    QToolTip::add(  Editor, tr( "Scriptfile editor" ) );
    QWhatsThis::add(  Editor, tr( "This window lets you edit your scriptfile by adding, removing, or modifying \
existing events. NOTE: it is not accessible if the real-time events are enabled in order to avoid interference \
between capturing the real-time events and modifying the scriptfile." ) );
    connect( Editor, SIGNAL ( cursorPositionChanged( int, int ) ), this, SLOT ( UpdateEditorLine( int, int ) ) );
    Tabs->insertTab( tab, tr( "Editor" ) );
    
/*
    tab_2 = new QWidget( Tabs, "tab_2" );
    tab_2->setFocusPolicy( QWidget::ClickFocus );
    Tabs->insertTab( tab_2, tr( "Track View" ) );
*/


    tab_3 = new QWidget( Tabs, "tab_3" );
    tab_3->setFocusPolicy( QWidget::ClickFocus );

    LocalhostGroupBox = new QGroupBox( tab_3, "LocalhostGroupBox" );
    LocalhostGroupBox->setGeometry( QRect( 10, 280, 727, 60 ) );
    LocalhostGroupBox->setTitle( tr( "Localhost Port (Slave)" ) );
    LocalhostGroupBox->setAlignment( int( QGroupBox::AlignHCenter ) );

    SocketLabel = new QLabel( LocalhostGroupBox, "SocketLabel" );
    SocketLabel->setGeometry( QRect( 10, 20, 50, 31 ) );
    SocketLabel->setText( tr( "Port:" ) );
    SocketLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    StatusLabel = new QLabel( LocalhostGroupBox, "StatusLabel" );
    StatusLabel->setGeometry( QRect( 180, 20, 50, 31 ) );
    StatusLabel->setText( tr( "Status:" ) );
    StatusLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    StopSocket = new QPushButton( LocalhostGroupBox, "StopSocket" );
    StopSocket->setAccel( CTRL+Key_Semicolon );
    StopSocket->setGeometry( QRect( 627, 20, 91, 31 ) );
    StopSocket->setFocusPolicy( QPushButton::StrongFocus );
    StopSocket->setText( tr( "Deactivate" ) );
    QToolTip::add(  StopSocket, tr( "Deactivate socket (Ctrl+;)" ) );
    QWhatsThis::add(  StopSocket, tr( "Deactivate socket, disabling client's ability to receive networked events." ) );

    StartSocket = new QPushButton( LocalhostGroupBox, "StartSocket" );
    StartSocket->setGeometry( QRect( 527, 20, 91, 31 ) );
    StartSocket->setAccel( CTRL+Key_Apostrophe );
    StartSocket->setFocusPolicy( QPushButton::StrongFocus );
    StartSocket->setText( tr( "Activate" ) );
    QToolTip::add(  StartSocket, tr( "Activate socket (Ctrl+')" ) );
    QWhatsThis::add(  StartSocket, tr( "Activate socket, enabling client to receive networked events." ) );

    Status = new QLabel( LocalhostGroupBox, "Status" );
    Status->setGeometry( QRect( 240, 20, 277, 30 ) );
    Status->setFrameShape( QLabel::StyledPanel );
    Status->setFrameShadow( QLabel::Sunken );
    Status->setText( tr( "OFF" ) );
    Status->setAlignment( int( QLabel::AlignCenter ) );
    QToolTip::add(  Status, tr( "Current localhost's status." ) );
    QWhatsThis::add(  Status, tr( "This Status-bar describes current status of the client's receiving socket." ) );

    Socket = new QLabel( LocalhostGroupBox, "Socket" );
    Socket->setGeometry( QRect( 70, 20, 100, 30 ) );
    Socket->setFrameShape( QLabel::StyledPanel );
    Socket->setFrameShadow( QLabel::Sunken );
    Socket->setText( tr( "9900" ) );
    Socket->setAlignment( int( QLabel::AlignCenter ) );
    QToolTip::add(  Socket, tr( "Current localhost's socket." ) );
    QWhatsThis::add(  Socket, tr( "This label states current client's receiving socket." ) );

    ExternalClientsGroupBox = new QGroupBox( tab_3, "ExternalClientsGroupBox" );
    ExternalClientsGroupBox->setGeometry( QRect( 10, 0, 727, 280 ) );
    ExternalClientsGroupBox->setTitle( tr( "External Clients" ) );
    ExternalClientsGroupBox->setAlignment( int( QGroupBox::AlignHCenter ) );

    ExternalClientsTable = new QTableDisplay( ExternalClientsGroupBox, "ExternalClientsTable" );
    ExternalClientsTable->setGeometry( QRect( 10, 20, 707, 210 ) );
    ExternalClientsTable->setFocusPolicy( QTable::NoFocus );
    ExternalClientsTable->setResizePolicy( QTable::Default );
    ExternalClientsTable->setNumRows( MAXNET+1 );
    ExternalClientsTable->setNumCols( 4 );
    ExternalClientsTable->setShowGrid( TRUE );
    ExternalClientsTable->setRowMovingEnabled( FALSE );
    ExternalClientsTable->setColumnMovingEnabled( FALSE );
    cgRT.setColor( QColorGroup::Foreground, backgroundColor() );
    cgRT.setColor( QColorGroup::Button, QColor( 239, 239, 239) );
    cgRT.setColor( QColorGroup::Light, white );
    cgRT.setColor( QColorGroup::Midlight, QColor( 247, 247, 247) );
    cgRT.setColor( QColorGroup::Dark, QColor( 119, 119, 119) );
    cgRT.setColor( QColorGroup::Mid, QColor( 159, 159, 159) );
    cgRT.setColor( QColorGroup::Text, QColor( 0, 0, 0) );
    cgRT.setColor( QColorGroup::BrightText, white );
    cgRT.setColor( QColorGroup::ButtonText, black );
    cgRT.setColor( QColorGroup::Base, backgroundColor() );
    cgRT.setBrush( QColorGroup::Background, backgroundColor() );
    cgRT.setColor( QColorGroup::Shadow, black );
    cgRT.setColor( QColorGroup::Highlight, QColor( 152, 167, 201) );
    cgRT.setColor( QColorGroup::HighlightedText, white );
    palRT.setActive( cgRT );
    palRT.setInactive( cgRT );
    palRT.setDisabled( cgRT );
    ExternalClientsTable->setPalette( palRT );
	QHeader *ptr = ExternalClientsTable->horizontalHeader();
	ptr->setLabel( 0, "Host", -1 );
	ptr->setLabel( 1, "Socket", -1 );
	ptr->setLabel( 2, "Status", -1 );
	ptr->setLabel( 3, "Send", -1 );
	//ptr->setLabel( 4, "Receive", -1 );
	ExternalClientsTable->setColumnWidth( 0, 385 );
	ExternalClientsTable->setColumnWidth( 1, 100 );
	ExternalClientsTable->setColumnWidth( 2, 117 );
	ExternalClientsTable->setColumnWidth( 3, 50 );
	//ExternalClientsTable->setColumnWidth( 4, 50 );
	ExternalClientsTable->setColumnStretchable( 0, FALSE );
	ExternalClientsTable->setColumnStretchable( 1, FALSE );
	ExternalClientsTable->setColumnStretchable( 2, FALSE );
	ExternalClientsTable->setColumnStretchable( 3, FALSE );
	//ExternalClientsTable->setColumnStretchable( 4, FALSE );
	ExternalClientsTable->setCurrentCell( -1, -1 );
	ExternalClientsTable->setSelectionMode( QTable::SingleRow );	
    QToolTip::add(  ExternalClientsTable, tr( "" ) );
    QWhatsThis::add(  ExternalClientsTable, tr( "Here you can review parameters of each of the networkable clients, their current status, as well as the network activity." ) );
	connect( ExternalClientsTable, SIGNAL ( pressed ( int, int, int, const QPoint & ) ), this, SLOT ( SelectExternalClient( int, int ) ) );
	connect( ExternalClientsTable, SIGNAL ( currentChanged ( int, int ) ), this, SLOT ( RemoveExternalClientSelection( int, int ) ) );
	connect( ExternalClientsTable, SIGNAL ( Unselected() ), this, SLOT ( ResetRow() ) );
	ExternalClientsTableSelected = -1;

    StartSelectedButton = new QPushButton( ExternalClientsGroupBox, "StartSelectedButton" );
	StartSelectedButton->setAccel( CTRL+Key_P );
    StartSelectedButton->setGeometry( QRect( 100, 240, 80, 31 ) );
    StartSelectedButton->setFocusPolicy( QPushButton::StrongFocus );
    StartSelectedButton->setText( tr( "Activate" ) );
    QToolTip::add(  StartSelectedButton, tr( "Activate selected client connection (Ctrl+P)" ) );
    QWhatsThis::add(  StartSelectedButton, tr( "By clicking on this button, you will connect to the selected client in the table above." ) );

    NetworkSpacerLine = new QFrame( ExternalClientsGroupBox, "NetworkSpacerLine" );
    NetworkSpacerLine->setGeometry( QRect( 180, 240, 20, 31 ) );
    NetworkSpacerLine->setFrameStyle( QFrame::VLine | QFrame::Sunken );

    StopAllButton = new QPushButton( ExternalClientsGroupBox, "StopAllButton" );
    StopAllButton->setGeometry( QRect( 200, 240, 91, 31 ) );
	StopAllButton->setAccel( CTRL+Key_BracketLeft );
    StopAllButton->setFocusPolicy( QPushButton::StrongFocus );
    StopAllButton->setText( tr( "Stop All" ) );
    QToolTip::add(  StopAllButton, tr( "Cease all network connections (Ctrl+[)" ) );
    QWhatsThis::add(  StopAllButton, tr( "By clicking on this button, an attempt will be made to cease all network communications with above-stated clients." ) );

    StartAllButton = new QPushButton( ExternalClientsGroupBox, "StartAllButton" );
    StartAllButton->setGeometry( QRect( 300, 240, 91, 31 ) );
	StartAllButton->setAccel( CTRL+Key_BracketRight );
    StartAllButton->setFocusPolicy( QPushButton::StrongFocus );
    StartAllButton->setText( tr( "Activate All" ) );
    QToolTip::add(  StartAllButton, tr( "Activate all connections (Ctrl+])" ) );
    QWhatsThis::add(  StartAllButton, tr( "By clicking on this button, all connections to other clients will be attempted. Their result will be posted in the status bar." ) );

    StopSelectedButton = new QPushButton( ExternalClientsGroupBox, "StopSelectedButton" );
    StopSelectedButton->setGeometry( QRect( 10, 240, 80, 31 ) );
	StopSelectedButton->setAccel( CTRL+Key_O );
    StopSelectedButton->setFocusPolicy( QPushButton::StrongFocus );
    StopSelectedButton->setText( tr( "Stop" ) );
    QToolTip::add(  StopSelectedButton, tr( "Stop selected client connection (Ctrl+O)" ) );
    QWhatsThis::add(  StopSelectedButton, tr( "By clicking on this button, you will stop the connection selected in the table above." ) );







    tab_4 = new QWidget( Tabs, "tab_4" );
	tab_4->setFocusPolicy( QWidget::ClickFocus );

    RTEventTable = new QTableDisplay( tab_4, "RTEventTable" );
    RTEventTable->setGeometry( QRect( 10, 20, 727, 280 ) );
    RTEventTable->setResizePolicy( QTable::Default );
    RTEventTable->setNumRows( MAXRTEVENTS+1 );
    RTEventTable->setNumCols( 4 );
    RTEventTable->setShowGrid( TRUE );
    RTEventTable->setRowMovingEnabled( FALSE );
    RTEventTable->setColumnMovingEnabled( FALSE );
    RTEventTable->setColumnWidth( 0, 90 );
    RTEventTable->setColumnWidth( 1, 300 );
    RTEventTable->setColumnWidth( 2, 212 );
    RTEventTable->setColumnWidth( 3, 50 );
    RTEventTable->setPalette( palRT );
    ptr = RTEventTable->horizontalHeader();
    ptr->setLabel( 0, "Event Name", -1 );
    ptr->setLabel( 1, "Description", -1 );
    ptr->setLabel( 2, "Trigger", -1 );
    ptr->setLabel( 3, "Status", -1 );
    RTEventTable->setColumnStretchable( 0, FALSE );
    RTEventTable->setColumnStretchable( 1, FALSE );
    RTEventTable->setColumnStretchable( 2, FALSE );
    RTEventTable->setColumnStretchable( 3, FALSE );
    RTEventTable->setCurrentCell( -1, -1 );
    RTEventTable->setSelectionMode( QTable::NoSelection );
    RTEventTable->setFocusPolicy( QTable::NoFocus );
    //RTEventTable->addSelection( QTableSelection::init( 1,1 ) );
    QToolTip::add(  RTEventTable, tr( "" ) );
    QWhatsThis::add(  RTEventTable, tr( "Here you can review what each real-time assigned event does and what triggers it (i.e. keypress, or an external interface event). EVENT describes exact assigned event, STATUS shows whether the event has been altered by the 'change' event, while TRIGGER shows the accelerator triggering the event." ) );
    connect( RTEventTable, SIGNAL ( currentChanged ( int, int ) ), RTEventTable, SLOT ( Unselect() ) );


    
    
    RTEventButton = new QPushButton( tab_4, "RTEventButton" );
    RTEventButton->setGeometry( QRect( 10, 310, 180, 30 ) );
    RTEventButton->setText( tr( "Toggle Real-Time Events" ) );
    RTEventButton->setAccel( CTRL+Key_T );
    RTEventButton->setToggleButton( TRUE );
    RTEventButton->setFlat( FALSE );
    QToolTip::add(  RTEventButton, tr( "Toggle real-time events on and off (Ctrl+T)" ) );
    QWhatsThis::add(  RTEventButton, tr( "Toggle accessibility of the real-time events on and off." ) );

    MIDIEventButton = new QPushButton( tab_4, "MIDIEventButton" );
    MIDIEventButton->setGeometry( QRect( 200, 310, 180, 30 ) );
    MIDIEventButton->setText( tr( "Toggle MIDI Monitoring" ) );
    MIDIEventButton->setAccel( CTRL+Key_Y );
    MIDIEventButton->setToggleButton( TRUE );
    MIDIEventButton->setFlat( FALSE );
    QToolTip::add(  MIDIEventButton, tr( "Toggle real-time MIDI events on and off (Ctrl+Y)" ) );
    QWhatsThis::add(  MIDIEventButton, tr( "Toggle accessibility of the real-time MIDI events on and off." ) );



    
    MIDILogButton = new QPushButton( tab_4, "MIDILogButton" );
    MIDILogButton->setGeometry( QRect( 487, 310, 100, 30 ) );
    MIDILogButton->setText( tr( "Midi Logging" ) );
    MIDILogButton->setAccel( CTRL + Key_U );
    MIDILogButton->setToggleButton( TRUE );
    MIDILogButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  MIDILogButton, tr( "Toggle MIDI-event Logging (Ctrl+U)" ) );
    QWhatsThis::add(  MIDILogButton, tr( "Toggle visibility of incoming MIDI events in the event log (useful for analyzing incoming MIDI messages).NOTE: heavily verbose output might hinder real-time performance." ) );

    VerboseButton = new QPushButton( tab_4, "VerboseButton" );
    VerboseButton->setGeometry( QRect( 597, 310, 100, 30 ) );
    VerboseButton->setText( tr( "Verbose" ) );
    VerboseButton->setAccel( CTRL + Key_I );
    VerboseButton->setToggleButton( TRUE );
    VerboseButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  VerboseButton, tr( "Toggle Verbose Run-time Logging (ON by default) (Ctrl+I)" ) );
    QWhatsThis::add(  VerboseButton, tr( "Toggle visibility of various run-time information (useful for debugging purposes). NOTE: heavily verbose output might hinder real-time performance." ) );
    
    RTPurgeButton = new QPushButton( tab_4, "RTPurgeButton" );
    RTPurgeButton->setGeometry( QRect( 707, 310, 30, 30 ) );
    RTPurgeButton->setPixmap( image1 );
    RTPurgeButton->setAccel( CTRL + Key_Delete );
    RTPurgeButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  RTPurgeButton, tr( "Purge Console (Ctrl+Del)" ) );
    QWhatsThis::add(  RTPurgeButton, tr( "Purge Console, thus rendering it completely empty." ) );



    
                                        
    RTEventLabel = new QLabel( tab_4, "RTEventLabel" );
    RTEventLabel->setGeometry( QRect( 260, 2, 221, 16 ) );
    RTEventLabel->setText( tr( "Real-time Events Matrix" ) );
    RTEventLabel->setAlignment( int( QLabel::AlignCenter ) );

    Tabs->insertTab( tab_4, tr( "RealTime" ) );
    Tabs->insertTab( tab_3, tr( "Network" ) );
    
    PlayButton = new QPushButton( this, "PlayButton" );
    PlayButton->setGeometry( QRect( 10, 10, 50, 40 ) );
    PlayButton->setCursor( QCursor( 0 ) );
    PlayButton->setText( tr( "" ) );
    PlayButton->setPixmap( image9 );
    //PlayButton->setAccel( CTRL + Key_Up );
    PlayButton->setToggleButton( TRUE );
    PlayButton->setFlat( FALSE );
    PlayButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  PlayButton, tr( "Play Button" ) );
    QWhatsThis::add(  PlayButton, tr( "Press this button to start performance" ) );

    PauseButton = new QPushButton( this, "PauseButton" );
    PauseButton->setGeometry( QRect( 70, 10, 40, 40 ) );
    PauseButton->setCursor( QCursor( 0 ) );
    PauseButton->setText( tr( "" ) );
    PauseButton->setPixmap( image10 );
    //PauseButton->setAccel( CTRL + Key_Shift );
    PauseButton->setToggleButton( TRUE );
    PauseButton->setOn( FALSE );
    PauseButton->setToggleButton( TRUE );
    PauseButton->setOn( FALSE );
    PauseButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  PauseButton, tr( "Pause Button" ) );
    QWhatsThis::add(  PauseButton, tr( "Pause Button for pausing of the performance... DUH! :-)" ) );

    RewindButton = new QPushButton( this, "RewindButton" );
    RewindButton->setGeometry( QRect( 120, 10, 40, 40 ) );
    RewindButton->setCursor( QCursor( 0 ) );
    RewindButton->setText( tr( "" ) );
    RewindButton->setPixmap( imageRewind );
    //RewindButton->setAccel( CTRL + Key_Left );
    RewindButton->setToggleButton( FALSE );
    RewindButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  RewindButton, tr( "Rewind Button" ) );
    QWhatsThis::add(  RewindButton, tr( "Rewind Button (only active when performance is suspended) moves you backward between set checkpoints in your scriptfile" ) );

    FForwardButton = new QPushButton( this, "FForwardButton" );
    FForwardButton->setGeometry( QRect( 170, 10, 40, 40 ) );
    FForwardButton->setCursor( QCursor( 0 ) );
    FForwardButton->setText( tr( "" ) );
    FForwardButton->setPixmap( imageFForward );
    //FForwardButton->setAccel( CTRL + Key_Right );
    FForwardButton->setToggleButton( FALSE );
    FForwardButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  FForwardButton, tr( "Fast Forward Button" ) );
    QWhatsThis::add(  FForwardButton, tr( "Fast Forward Button (only active when performance is suspended) moves you forward between set checkpoints in your scriptfile" ) );

    StopButton = new QPushButton( this, "StopButton" );
    StopButton->setGeometry( QRect( 220, 10, 40, 40 ) );
    StopButton->setCursor( QCursor( 0 ) );
    StopButton->setText( tr( "" ) );
    StopButton->setPixmap( image13 );
    //StopButton->setAccel( CTRL + Key_Down );
    StopButton->setFlat( FALSE );
	StopButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  StopButton, tr( "Stop Button" ) );
    QWhatsThis::add(  StopButton, tr( "Press this to stop the performance timer (running processes will continue to sound until killed or finished), if you press it while performance is stopped, it will reset the counter to zero and stop all events that have their 'kill' value defined" ) );

    PanicButton = new QPushButton( this, "PanicButton" );
    PanicButton->setGeometry( QRect( 280, 10, 50, 40 ) );
    PanicButton->setCursor( QCursor( 0 ) );
    PanicButton->setText( tr( "" ) );
    PanicButton->setPixmap( image14 );
    //PanicButton->setAccel( CTRL + Key_Return );
    PanicButton->setFlat( FALSE );
	PanicButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  PanicButton, tr( "Panic Button" ) );
    QWhatsThis::add(  PanicButton, tr( "Panic button stops all audio activity by muting audio and stopping all events which have their 'kill' value defined" ) );

    SizeButton = new QPushButton( this, "SizeButton" );
    SizeButton->setGeometry( QRect( 340, 10, 40, 40 ) );
    SizeButton->setText( tr( "" ) );
    SizeButton->setPixmap( image15 );
    SizeButton->setAccel( Key_F3 );
    SizeButton->setToggleButton( TRUE );
    SizeButton->setFlat( FALSE );
	SizeButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  SizeButton, tr( "Size Toggle Button" ) );
    QWhatsThis::add(  SizeButton, tr( "Size toggle button toggles between compact and full-size view (a.k.a. performance and rehearsal mode)" ) );

    WhatIsThisButton = new QPushButton( this, "WhatIsThisButton" );
    WhatIsThisButton->setGeometry( QRect( 400, 10, 40, 40 ) );
    WhatIsThisButton->setCursor( QCursor( 0 ) );
    WhatIsThisButton->setText( tr( "" ) );
    WhatIsThisButton->setPixmap( image16 );
    WhatIsThisButton->setAccel( Key_F1 );
    WhatIsThisButton->setFlat( FALSE );
	WhatIsThisButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  WhatIsThisButton, tr( "What is This? (F1)" ) );
    QWhatsThis::add(  WhatIsThisButton, tr( "This will enable you to learn more about the interface by clicking on the part of the interface in question" ) );

    AboutButton = new QPushButton( this, "AboutButton" );
    AboutButton->setGeometry( QRect( 450, 10, 40, 40 ) );
    AboutButton->setCursor( QCursor( 0 ) );
    AboutButton->setText( tr( "" ) );
    AboutButton->setPixmap( image17 );
    AboutButton->setAccel( Key_F2 );
    AboutButton->setFlat( FALSE );
    QToolTip::add(  AboutButton, tr( "Preferences/About/Help (F2)" ) );
    QWhatsThis::add(  AboutButton, tr( "Adjust preferences, access content help, and find more about this application and its author." ) );

    QuitButton = new QPushButton( this, "QuitButton" );
    QuitButton->setGeometry( QRect( 510, 10, 40, 40 ) );
    QuitButton->setCursor( QCursor( 0 ) );
    QuitButton->setText( tr( "" ) );
    QuitButton->setPixmap( image18 );
    QuitButton->setAccel( CTRL + Key_Q );
    QuitButton->setFlat( FALSE );
	QuitButton->setFocusPolicy( QWidget::StrongFocus );
    QToolTip::add(  QuitButton, tr( "Quit Application (Ctrl+Q)" ) );
    QWhatsThis::add(  QuitButton, tr( "Quit Application" ) );

    WarnGroupBox = new QGroupBox( this, "WarnGroupBox" );
    WarnGroupBox->setGeometry( QRect( 10, 210, 750, 160 ) );
    WarnGroupBox->setFrameShape( QGroupBox::Box );
    WarnGroupBox->setTitle( tr( "Warning Countdown Timer" ) );
	WarnGroupBox->setFocusPolicy( QWidget::ClickFocus );
    WarnGroupBox->setAlignment( int( QGroupBox::AlignHCenter ) );

    NWarnTenMinute = new QLCDNumber( WarnGroupBox, "NWarnTenMinute" );
    NWarnTenMinute->setGeometry( QRect( 180, 20, 65, 110 ) );
    cgWarn.setColor( QColorGroup::Foreground, QColor( 85, 255, 0) );
    cgWarn.setColor( QColorGroup::Button, QColor( 85, 255, 0) );
    cgWarn.setColor( QColorGroup::Light, QColor( 170, 255, 127) );
    cgWarn.setColor( QColorGroup::Midlight, QColor( 127, 255, 63) );
    cgWarn.setColor( QColorGroup::Dark, QColor( 42, 127, 0) );
    cgWarn.setColor( QColorGroup::Mid, QColor( 57, 170, 0) );
    cgWarn.setColor( QColorGroup::Text, white );
    cgWarn.setColor( QColorGroup::BrightText, white );
    cgWarn.setColor( QColorGroup::ButtonText, white );
    cgWarn.setColor( QColorGroup::Base, black );
    cgWarn.setColor( QColorGroup::Background, black );
    cgWarn.setColor( QColorGroup::Shadow, black );
    cgWarn.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cgWarn.setColor( QColorGroup::HighlightedText, white );
    palWarn.setActive( cgWarn );
    palWarn.setInactive( cgWarn );
    palWarn.setDisabled( cgWarn );
    NWarnTenMinute->setPalette( palWarn );
    NWarnTenMinute->setCursor( QCursor( 0 ) );
    NWarnTenMinute->setMouseTracking( FALSE );
    NWarnTenMinute->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnTenMinute->setAcceptDrops( FALSE );
    NWarnTenMinute->setAutoMask( FALSE );
    NWarnTenMinute->setFrameShape( QLCDNumber::NoFrame );
    NWarnTenMinute->setFrameShadow( QLCDNumber::Plain );
    NWarnTenMinute->setLineWidth( 2 );
    NWarnTenMinute->setMargin( 0 );
    NWarnTenMinute->setMidLineWidth( 0 );
    NWarnTenMinute->setSmallDecimalPoint( FALSE );
    NWarnTenMinute->setNumDigits( 1 );
    NWarnTenMinute->setSegmentStyle( QLCDNumber::Filled );
    NWarnTenMinute->setProperty( "intValue", 0 );

    NWarnMinute = new QLCDNumber( WarnGroupBox, "NWarnMinute" );
    NWarnMinute->setGeometry( QRect( 245, 20, 65, 110 ) );
    NWarnMinute->setPalette( palWarn );
    NWarnMinute->setCursor( QCursor( 0 ) );
    NWarnMinute->setMouseTracking( FALSE );
    NWarnMinute->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnMinute->setAcceptDrops( FALSE );
    NWarnMinute->setAutoMask( FALSE );
    NWarnMinute->setFrameShape( QLCDNumber::NoFrame );
    NWarnMinute->setFrameShadow( QLCDNumber::Plain );
    NWarnMinute->setLineWidth( 2 );
    NWarnMinute->setMargin( 0 );
    NWarnMinute->setMidLineWidth( 0 );
    NWarnMinute->setSmallDecimalPoint( FALSE );
    NWarnMinute->setNumDigits( 1 );
    NWarnMinute->setSegmentStyle( QLCDNumber::Filled );
    NWarnMinute->setProperty( "intValue", 0 );

    NWarnTenSecond = new QLCDNumber( WarnGroupBox, "NWarnTenSecond" );
    NWarnTenSecond->setGeometry( QRect( 350, 20, 65, 110 ) );
    NWarnTenSecond->setPalette( palWarn );
    NWarnTenSecond->setCursor( QCursor( 0 ) );
    NWarnTenSecond->setMouseTracking( FALSE );
    NWarnTenSecond->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnTenSecond->setAcceptDrops( FALSE );
    NWarnTenSecond->setAutoMask( FALSE );
    NWarnTenSecond->setFrameShape( QLCDNumber::NoFrame );
    NWarnTenSecond->setFrameShadow( QLCDNumber::Plain );
    NWarnTenSecond->setLineWidth( 2 );
    NWarnTenSecond->setMargin( 0 );
    NWarnTenSecond->setMidLineWidth( 0 );
    NWarnTenSecond->setSmallDecimalPoint( FALSE );
    NWarnTenSecond->setNumDigits( 1 );
    NWarnTenSecond->setSegmentStyle( QLCDNumber::Filled );
    NWarnTenSecond->setProperty( "intValue", 0 );

    NWarnSecond = new QLCDNumber( WarnGroupBox, "NWarnSecond" );
    NWarnSecond->setGeometry( QRect( 415, 20, 65, 110 ) );
    NWarnSecond->setPalette( palWarn );
    NWarnSecond->setCursor( QCursor( 0 ) );
    NWarnSecond->setMouseTracking( FALSE );
    NWarnSecond->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnSecond->setAcceptDrops( FALSE );
    NWarnSecond->setAutoMask( FALSE );
    NWarnSecond->setFrameShape( QLCDNumber::NoFrame );
    NWarnSecond->setFrameShadow( QLCDNumber::Plain );
    NWarnSecond->setLineWidth( 2 );
    NWarnSecond->setMargin( 0 );
    NWarnSecond->setMidLineWidth( 0 );
    NWarnSecond->setSmallDecimalPoint( FALSE );
    NWarnSecond->setNumDigits( 1 );
    NWarnSecond->setSegmentStyle( QLCDNumber::Filled );
    NWarnSecond->setProperty( "intValue", 0 );

    WarnExecute = new QLED( WarnGroupBox, "WarnExecute" );
    WarnExecute->setGeometry( QRect( 630, 20, 110, 110 ) );
    WarnExecute->setLineWidth( 0 );
    //WarnExecute->setPixmap( imageGreenoff );
    WarnExecute->setScaledContents( TRUE );
    QToolTip::add(  WarnExecute, tr( "Execute Indicator" ) );

    WarningSecondsLabel = new QLabel( WarnGroupBox, "WarningSecondsLabel" );
    WarningSecondsLabel->setGeometry( QRect( 360, 130, 110, 21 ) );
    WarningSecondsLabel->setText( tr( "Seconds" ) );
    WarningSecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    WarningIndicatorLabel = new QLabel( WarnGroupBox, "WarningIndicatorLabel" );
    WarningIndicatorLabel->setGeometry( QRect( 25, 130, 120, 21 ) );
    WarningIndicatorLabel->setText( tr( "Warning Indicator" ) );
    WarningIndicatorLabel->setAlignment( int( QLabel::AlignCenter ) );

    WarningMinutesLabel = new QLabel( WarnGroupBox, "WarningMinutesLabel" );
    WarningMinutesLabel->setGeometry( QRect( 190, 130, 110, 21 ) );
    WarningMinutesLabel->setText( tr( "Minutes" ) );
    WarningMinutesLabel->setAlignment( int( QLabel::AlignCenter ) );

    ExecuteIndicatorLabel = new QLabel( WarnGroupBox, "ExecuteIndicatorLabel" );
    ExecuteIndicatorLabel->setGeometry( QRect( 630, 130, 110, 21 ) );
    ExecuteIndicatorLabel->setText( tr( "Execute Indicator" ) );
    ExecuteIndicatorLabel->setAlignment( int( QLabel::AlignCenter ) );

    WarningDecisecondsLabel = new QLabel( WarnGroupBox, "WarningDecisecondsLabel" );
    WarningDecisecondsLabel->setGeometry( QRect( 520, 130, 80, 21 ) );
    WarningDecisecondsLabel->setText( tr( "Centiseconds" ) );
    WarningDecisecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    NWarnCentisecond = new QLCDNumber( WarnGroupBox, "NWarnCentisecond" );
    NWarnCentisecond->setGeometry( QRect( 560, 20, 50, 110 ) );
    NWarnCentisecond->setPalette( palWarn );
    NWarnCentisecond->setCursor( QCursor( 0 ) );
    NWarnCentisecond->setMouseTracking( FALSE );
    NWarnCentisecond->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnCentisecond->setAcceptDrops( FALSE );
    NWarnCentisecond->setAutoMask( FALSE );
    NWarnCentisecond->setFrameShape( QLCDNumber::NoFrame );
    NWarnCentisecond->setFrameShadow( QLCDNumber::Plain );
    NWarnCentisecond->setLineWidth( 1 );
    NWarnCentisecond->setMargin( 0 );
    NWarnCentisecond->setMidLineWidth( 0 );
    NWarnCentisecond->setSmallDecimalPoint( FALSE );
    NWarnCentisecond->setNumDigits( 1 );
    NWarnCentisecond->setMode( QLCDNumber::DEC );
    NWarnCentisecond->setSegmentStyle( QLCDNumber::Filled );
    NWarnCentisecond->setProperty( "intValue", 0 );

    NWarnTenCentisecond = new QLCDNumber( WarnGroupBox, "NWarnTenCentisecond" );
    NWarnTenCentisecond->setGeometry( QRect( 510, 20, 50, 110 ) );
    NWarnTenCentisecond->setPalette( palWarn );
    NWarnTenCentisecond->setCursor( QCursor( 0 ) );
    NWarnTenCentisecond->setMouseTracking( FALSE );
    NWarnTenCentisecond->setFocusPolicy( QLCDNumber::NoFocus );
    NWarnTenCentisecond->setAcceptDrops( FALSE );
    NWarnTenCentisecond->setAutoMask( FALSE );
    NWarnTenCentisecond->setFrameShape( QLCDNumber::NoFrame );
    NWarnTenCentisecond->setFrameShadow( QLCDNumber::Plain );
    NWarnTenCentisecond->setLineWidth( 1 );
    NWarnTenCentisecond->setMargin( 0 );
    NWarnTenCentisecond->setMidLineWidth( 0 );
    NWarnTenCentisecond->setSmallDecimalPoint( FALSE );
    NWarnTenCentisecond->setNumDigits( 1 );
    NWarnTenCentisecond->setMode( QLCDNumber::DEC );
    NWarnTenCentisecond->setSegmentStyle( QLCDNumber::Filled );
    NWarnTenCentisecond->setProperty( "intValue", 0 );

    WarningLeftEdge = new QLabel( WarnGroupBox, "WarningLeftEdge" );
    WarningLeftEdge->setGeometry( QRect( 170, 20, 10, 110 ) );
    WarningLeftEdge->setPixmap( image2 );
    WarningLeftEdge->setScaledContents( TRUE );

    WarningRightEdge = new QLabel( WarnGroupBox, "WarningRightEdge" );
    WarningRightEdge->setGeometry( QRect( 610, 20, 10, 110 ) );
    WarningRightEdge->setPixmap( image3 );
    WarningRightEdge->setScaledContents( TRUE );

    WarnMinuteSecondColumn = new QLCDNumber( WarnGroupBox, "WarnMinuteSecondColumn" );
    WarnMinuteSecondColumn->setGeometry( QRect( 310, 20, 40, 110 ) );
    WarnMinuteSecondColumn->setPalette( palWarn );
    WarnMinuteSecondColumn->setCursor( QCursor( 0 ) );
    WarnMinuteSecondColumn->setMouseTracking( FALSE );
    WarnMinuteSecondColumn->setFocusPolicy( QLCDNumber::NoFocus );
    WarnMinuteSecondColumn->setAcceptDrops( FALSE );
    WarnMinuteSecondColumn->setAutoMask( FALSE );
    WarnMinuteSecondColumn->setFrameShape( QLCDNumber::NoFrame );
    WarnMinuteSecondColumn->setFrameShadow( QLCDNumber::Plain );
    WarnMinuteSecondColumn->setLineWidth( 2 );
    WarnMinuteSecondColumn->setMargin( 0 );
    WarnMinuteSecondColumn->setMidLineWidth( 0 );
    WarnMinuteSecondColumn->setSmallDecimalPoint( FALSE );
    WarnMinuteSecondColumn->setNumDigits( 1 );
    WarnMinuteSecondColumn->setMode( QLCDNumber::DEC );
    WarnMinuteSecondColumn->setSegmentStyle( QLCDNumber::Filled );
	WarnMinuteSecondColumn->display( ":" );

    WarnSecondCentisecondDot = new QLCDNumber( WarnGroupBox, "WarnSecondCentisecondDot" );
    WarnSecondCentisecondDot->setGeometry( QRect( 480, 20, 30, 110 ) );
    WarnSecondCentisecondDot->setPalette( palWarn );
    WarnSecondCentisecondDot->setCursor( QCursor( 0 ) );
    WarnSecondCentisecondDot->setMouseTracking( FALSE );
    WarnSecondCentisecondDot->setFocusPolicy( QLCDNumber::NoFocus );
    WarnSecondCentisecondDot->setAcceptDrops( FALSE );
    WarnSecondCentisecondDot->setAutoMask( FALSE );
    WarnSecondCentisecondDot->setFrameShape( QLCDNumber::NoFrame );
    WarnSecondCentisecondDot->setFrameShadow( QLCDNumber::Plain );
    WarnSecondCentisecondDot->setLineWidth( 2 );
    WarnSecondCentisecondDot->setMargin( 0 );
    WarnSecondCentisecondDot->setMidLineWidth( 0 );
    WarnSecondCentisecondDot->setSmallDecimalPoint( FALSE );
    WarnSecondCentisecondDot->setNumDigits( 1 );
    WarnSecondCentisecondDot->setMode( QLCDNumber::DEC );
    WarnSecondCentisecondDot->setSegmentStyle( QLCDNumber::Filled );
    WarnSecondCentisecondDot->display( "." );

    WarnIndicator = new QLED( WarnGroupBox, "WarnIndicator" );
    WarnIndicator->setGeometry( QRect( 30, 20, 110, 110 ) );
    WarnIndicator->setFrameShape( QLabel::NoFrame );
    WarnIndicator->setFrameShadow( QLabel::Plain );
    WarnIndicator->setLineWidth( 0 );
    //WarnIndicator->setPixmap( imageYellowoff );
    WarnIndicator->setScaledContents( TRUE );
    QToolTip::add(  WarnIndicator, tr( "Warning Indicator" ) );

    // tab order
    setTabOrder( PlayButton, PauseButton );
    setTabOrder( PauseButton, RewindButton );
    setTabOrder( RewindButton, FForwardButton );
    setTabOrder( FForwardButton, StopButton );
    setTabOrder( StopButton, PanicButton );
    setTabOrder( PanicButton, SizeButton );
    setTabOrder( SizeButton, WhatIsThisButton );
    setTabOrder( WhatIsThisButton, AboutButton );
    setTabOrder( AboutButton, QuitButton );
    setTabOrder( QuitButton, Tabs );
    setTabOrder( Tabs, NewButton );
    setTabOrder( NewButton, OpenButton );
    setTabOrder( OpenButton, SaveButton );
    setTabOrder( SaveButton, SaveAsButton );
    setTabOrder( SaveAsButton, PurgeButton );
    setTabOrder( PurgeButton, RefreshButton );
    setTabOrder( RefreshButton, EditButton );
    setTabOrder( EditButton, ErrorButton );
    setTabOrder( ErrorButton, CompileButton );
    setTabOrder( CompileButton, StopSelectedButton );
    setTabOrder( StopSelectedButton, StartSelectedButton );
    setTabOrder( StartSelectedButton, StopAllButton );
    setTabOrder( StartAllButton, StopSocket );
    setTabOrder( StopSocket, StartSocket );
    setTabOrder( StartSocket, RTEventButton );
    setTabOrder( RTEventButton, MIDIEventButton );
    setTabOrder( MIDIEventButton, MIDILogButton );
    setTabOrder( MIDILogButton, VerboseButton );
    setTabOrder( VerboseButton, RTPurgeButton );
    setTabOrder( RTPurgeButton, PlayButton );
    
    //BASIC TRANSPORT CONTROLLS========================
    connect ( AboutButton, SIGNAL ( clicked() ), this, SLOT ( OpenSettings() ) );

    connect ( PlayButton, SIGNAL ( clicked() ), this, SLOT ( Do_Play() ) );
    connect ( PauseButton, SIGNAL ( clicked() ), this, SLOT ( Do_Pause() ) );
    connect ( StopButton, SIGNAL ( clicked() ), this, SLOT ( Do_Stop() ) );
    connect ( RewindButton, SIGNAL ( clicked() ), this, SLOT ( REW() ) );
    connect ( FForwardButton, SIGNAL ( clicked() ), this, SLOT ( FF() ) );

    connect ( SizeButton, SIGNAL ( stateChanged( int ) ), this, SLOT ( ToggleSize( int ) ) );
    connect ( QuitButton, SIGNAL ( clicked() ), this, SLOT ( Quit() ) );

    connect ( NHour, SIGNAL ( lclicked() ), this, SLOT ( IncreaseHour() ) );
    connect ( NHour, SIGNAL ( rclicked() ), this, SLOT ( DecreaseHour() ) );

    connect ( NTenMinute, SIGNAL ( lclicked() ), this, SLOT ( IncreaseTenMinute() ) );
    connect ( NTenMinute, SIGNAL ( rclicked() ), this, SLOT ( DecreaseTenMinute() ) );

    connect ( NMinute, SIGNAL ( lclicked() ), this, SLOT ( IncreaseMinute() ) );
    connect ( NMinute, SIGNAL ( rclicked() ), this, SLOT ( DecreaseMinute() ) );

    connect ( NTenSecond, SIGNAL ( lclicked() ), this, SLOT ( IncreaseTenSecond() ) );
    connect ( NTenSecond, SIGNAL ( rclicked() ), this, SLOT ( DecreaseTenSecond() ) );

    connect ( NSecond, SIGNAL ( lclicked() ), this, SLOT ( IncreaseSecond() ) );
    connect ( NSecond, SIGNAL ( rclicked() ), this, SLOT ( DecreaseSecond() ) );

    connect ( NTenCentisecond, SIGNAL ( lclicked() ), this, SLOT ( IncreaseTenCentisecond() ) );
    connect ( NTenCentisecond, SIGNAL ( rclicked() ), this, SLOT ( DecreaseTenCentisecond() ) );

    connect ( NCentisecond, SIGNAL ( lclicked() ), this, SLOT ( IncreaseCentisecond() ) );
    connect ( NCentisecond, SIGNAL ( rclicked() ), this, SLOT ( DecreaseCentisecond() ) );

    connect ( WhatIsThisButton, SIGNAL ( clicked() ), this, SLOT ( HelpMode() ) );

    connect ( PanicButton, SIGNAL ( clicked() ), this, SLOT ( Do_Panic() ) );

    connect ( PurgeButton, SIGNAL ( clicked() ), this, SLOT ( Purge() ) );
    connect ( EditButton, SIGNAL (clicked() ), this, SLOT ( OpenExternEditor() ) );
    connect ( RefreshButton, SIGNAL (clicked() ), this, SLOT ( RefreshEditor() ) );
    connect ( ErrorButton, SIGNAL (clicked() ), this, SLOT ( OpenConsole() ) );
    connect ( GoToButton, SIGNAL (clicked() ), this, SLOT ( GoToError() ) );

    //NETWORK TAB BUTTONS
    connect ( StopSelectedButton, SIGNAL ( clicked() ), this, SLOT ( StopSelectedClient() ) );
    connect ( StartSelectedButton, SIGNAL ( clicked() ), this, SLOT ( StartSelectedClient() ) );
    connect ( StopAllButton, SIGNAL ( clicked() ), this, SLOT ( StopAllClients() ) );
    connect ( StartAllButton, SIGNAL ( clicked() ), this, SLOT ( StartAllClients() ) );
    connect ( StopSocket, SIGNAL ( clicked() ), this, SLOT ( StopHost() ) );
    connect ( StartSocket, SIGNAL ( clicked() ), this, SLOT ( StartHost() ) );

    //FILE OPEN STUFF ================================
    connect (OpenButton, SIGNAL ( clicked() ), this, SLOT ( OpenFile() ) );
    connect (NewButton, SIGNAL ( clicked() ), this, SLOT ( New() ) );

    //FILE SAVE STUFF ================================
    connect (SaveButton, SIGNAL ( clicked() ), this, SLOT ( SaveFile() ) );

    //FILE SAVE-AS STUFF ================================
    connect (SaveAsButton, SIGNAL ( clicked() ), this, SLOT ( SaveAsFile() ) );

    //COMPILE STUFF ==================================
    connect ( CompileButton, SIGNAL (clicked() ), this, SLOT ( Compile() ) );

    PlaybackStatus = 0;
/* 0 is stopped
*  1 is rew
*  2 is ffw
*  3 is paused
*  4 is playing
*/

	TimeCount = 0; //Actual time counter
	PauseCounter = 0;
	WarningCount = 0;
	CountdownCount = 0;

	RandSeed = 1;
	OldPlaybackStatus = 0;
	CompileComments = false;

	Edit = true;

	inputFile = "0";
	outputFile = "0";

	//EVENTCUE STUFF ================================
	Start = new eventCue;

	Start->event = "start";
	Start->killEvent = "none";
	Start->text = "none";
	Start->say= "none";
	Start->ID = 0;
	Start->time = 0;
	Start->countdown = 0;
	Start->happen = 1;
	Start->chance = 1;
	Start->color = "0";
	Start->light = 0;	
	Start->prev = NULL;
	Start->next = NULL;
	Start->blinkSpeed = 0;
	Start->prepLength = 0;
	Start->lightLength = 0;
	Start->netAddress = 0;
	Start->bpm = 0;
   Start->OSCPtr = NULL;
   Start->accel = "none";
   Start->la = -1;
   Start->ha = -1;
   Start->lb = -1;
   Start->hb = -1;
   Start->lc = -1;
   Start->hc = -1;

	StartCopy = new eventCue;
	*StartCopy = *Start;
	EndCopy = StartCopy;
	MoveCopy = StartCopy;
	CurrCopy = StartCopy;

	End = Start;
	Curr = Start;
	Move = Start;
	FollowMove = NULL;
	AbsMove = NULL;

	EventPtr = NULL;
	CountdownPtr = NULL;
	TextPtr = NULL;
	CheckpointPtr = NULL;
	//PausePtr = NULL;
	//StopPtr = NULL;
	ClearPtr = NULL;
	WarningPtr = NULL;
	MetroPtr = NULL;
	JumpPtr = NULL;
	RandPtr = NULL;
	ChangePtr = NULL;
	SeedPtr = NULL;
	RewPtr = NULL;
	FfwPtr = NULL;
	ToggleMetroPtr = NULL;
	AssignPtr = NULL;
	ToggleRTPtr = NULL;
	//SetNetPtr = NULL;
	ToggleNetPtr = NULL;
	ToggleMIDIPtr = NULL;
	PlayPtr = NULL;
  
    for ( int n = 0; n < MAXRTEVENTS; n++ )
    {
        RTEvents[n] = NULL;
        RTEventsCopy[n] = NULL;
        net[n] = NULL;
    }

	nEvents = 0;
	CurrSize = false; //Window is full size by default

	socket = 9900;
	NetActive = false;
	HostingActive = false;
	local = NULL;
	//local = new SimpleServer( this, this, socket );
	//connect( local, SIGNAL ( newConnect( QString ) ), this, SLOT ( UpdateHostStatus( QString ) ) );	

	compareFile = "";
	compareCompile = "";

	//WarnEvent = "none";
    Window1 = new Warning_Window();
	Window1->SetName( "W-1", "Player 1" );
	Window2 = new Warning_Window();
	Window2->SetName( "W-2","Player 2" );
	Window3 = new Warning_Window();
	Window3->SetName( "W-3","Player 3" );
	Window4 = new Warning_Window();
	Window4->SetName( "W-4","Player 4" );
    connect( Window1, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Window1, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Window2, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Window2, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Window3, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Window3, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Window4, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Window4, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    
	Metro1 = new Metronome();
	Metro1->UpdateName("M-1","Metro 1");
	Metro2 = new Metronome();
    Metro2->UpdateName("M-2","Metro 2");
    Metro3 = new Metronome();
    Metro3->UpdateName("M-3","Metro 3");
    Metro4 = new Metronome();
    Metro4->UpdateName("M-4","Metro 4");
    connect ( Metro1, SIGNAL ( MeterParseError( QString ) ), this, SLOT ( EmitMetroError( QString ) ) );
    connect ( Metro2, SIGNAL ( MeterParseError( QString ) ), this, SLOT ( EmitMetroError( QString ) ) );
    connect ( Metro3, SIGNAL ( MeterParseError( QString ) ), this, SLOT ( EmitMetroError( QString ) ) );
    connect ( Metro4, SIGNAL ( MeterParseError( QString ) ), this, SLOT ( EmitMetroError( QString ) ) );
    connect( Metro1, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Metro1, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Metro2, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Metro2, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Metro3, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Metro3, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    connect( Metro4, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( Metro4, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );

    netEvents = "";
    Midi = NULL;
  
    LEDw = new LEDWindow();
    connect( LEDw, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( LEDw, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );  

    //CONSOLE
    T = new TextWindow( NULL, this );
    connect( T, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( T, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) );
    T->start();   
    E = new ExternalTimer();
    connect( E, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( E, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) ); 
    A = new ExternalTimer();
    A->ChangeName( "Absolute Time Counter" );
    connect( A, SIGNAL ( KeyPress( QKeyEvent* ) ), this, SLOT ( ReceiveKeyPressEvent( QKeyEvent* ) ) );
    connect( A, SIGNAL ( KeyRelease( QKeyEvent* ) ), this, SLOT ( ReceiveKeyReleaseEvent( QKeyEvent* ) ) ); 
    Error( "Welcome to the RTMix v." + Version + "!<br> Copyright <b>Ivica Ico Bukvic</b> 2001\n" );

    S = new settings( 0, 0, 0, this );
    connect ( SizeButton, SIGNAL ( stateChanged( int ) ), S, SLOT ( setWinSize( int ) ) );

    //int w = RTMix::x() + 138;
    //int h = RTMix::y() + 147;
    //if ( w < 0 ) { w = 0; }
    //if ( h < 0 ) { h = 0; }
    //S->move( w, h );

    //RT STUFF
    Sp->UpdateSplash( Sp->ProgressBar->totalSteps()-1, "Spawning MIDI Thread" );
    SpawnMidi( S->GetMidiPort() );
    connect ( RTPurgeButton, SIGNAL ( clicked() ), this, SLOT ( Purge() ) );
    connect ( MIDILogButton, SIGNAL ( toggled( bool ) ), this, SLOT ( ToggleMidiLog( bool ) ) );
    connect ( VerboseButton, SIGNAL ( toggled( bool ) ), this, SLOT ( ToggleVerbose( bool ) ) );
    connect ( MIDILogButton, SIGNAL ( toggled( bool ) ), T, SLOT ( ToggleMMidiLog( bool ) ) );
    connect ( VerboseButton, SIGNAL ( toggled( bool ) ), T, SLOT ( ToggleMVerbose( bool ) ) );
    connect ( RTEventButton, SIGNAL ( toggled( bool ) ), this, SLOT ( AnnounceRT(bool) ) );
    connect ( RTEventButton, SIGNAL ( toggled( bool ) ), T, SLOT ( ToggleMRt(bool) ) );
    connect ( MIDIEventButton, SIGNAL ( toggled( bool ) ), this, SLOT ( AnnounceMIDI(bool) ) );
    MIDIEventButton->setEnabled( FALSE );
    MIDILogButton->setEnabled( FALSE );
    haveOSC = FALSE;
    midi_1 = -1;
    midi_2 = -1;
    midi_3 = -1;

    //Used for detection of a recursion in the networking
    LastSent = "";
    //LastSentTime = -1;

    CompileFlag = FALSE;
    ErrorCompile = FALSE;
    Verbose = FALSE;
    //VerboseButton->setOn( TRUE );
    Error("Verbose Console output disabled.");
    timer = new MyTimer( this, "timer" );
    timer->start();

    Sp->UpdateSplash( Sp->ProgressBar->totalSteps(), "OK I'm Ready" );        
    qApp->setMainWidget( this );
    T->show();
    Sp->Close();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
RTMix::~RTMix()
{
	//Sp->showNormal();
	//Sp->UpdateSplash( 0, "Purging Cues" );
	//qApp->processEvents();
	RTMix::PurgeCue();
	delete Start;
	delete StartCopy;
	for ( int n = 0; n < MAXNET; n++ )
	{
     	if ( net[n] != NULL ) { delete net[n]; }
		//if ( RTEvents[n] != NULL ) { delete RTEvents[n]; }
		//if ( RTEventsCopy[n] != NULL ) { delete RTEventsCopy[n]; }
	}
	QTextStream cout( stdout, IO_WriteOnly );
    // no need to delete child widgets, Qt does it all for us
	//Sp->UpdateSplash( 30 , "Saving Settings" );
	//qApp->processEvents();
	S->SaveSettings();
	//Sp->UpdateSplash( 55, "OK Exiting" );
	//qApp->processEvents();
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
bool RTMix::event( QEvent* ev )
{
    bool ret = QWidget::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange ) {
	QFont TextInterface_font(  TextInterface->font() );
	TextInterface_font.setPointSize( 11 );
	TextInterface->setFont( TextInterface_font ); 
    }
    return ret;
}
*/

void RTMix::closeEvent ( QCloseEvent *e )
{
	Quit();
}

void RTMix::keyPressEvent ( QKeyEvent *k )
{
    //qDebug( "%d", k->isAutoRepeat() );
    if ( !k->isAutoRepeat() )
    {
        //qDebug("not a repeat");
        QString s;
        //TextInterface->append ( s.setNum( k->key(), 10 ) );

        if ( k->state() == AltButton )
        {
            if ( k->text() == "1" )
            {
                Tabs->setCurrentPage( 0 );
            }
            else if ( k->text() == "2" )
            {
                Tabs->setCurrentPage( 1 );
            }
            else if ( k->text() == "3" )
            {
                Tabs->setCurrentPage( 2 );
            }
            else if ( k->text() == "4" )
            {
                Tabs->setCurrentPage( 3 );
            }
            else if ( k->text() == "5" )
            {
                Tabs->setCurrentPage( 4 );
            }
        }
        if ( /*PlaybackStatus >= 3 &&*/ RTEventButton->isOn() )
        {
            QString rtn;
            //qDebug( "press: %d", k->key() );
            //REAL-TIME ACCELERATORS
            for ( int n = 0; n < MAXRTEVENTS; n++ )
            {
                if ( RTEvents[n] != NULL )
                {
                    if ( k->text() == RTEvents[n]->accel )
                    {
                        Error( " -- Real-time event no." + rtn.setNum( n+1, 10 ) + " triggered...\n" );
                        T->ToggleAKeys( true );
                        InterpretCue( RTEvents[n] );
                    }
                }
            }
        }
    }
}

void RTMix::keyReleaseEvent ( QKeyEvent *k )
{
    if ( !k->isAutoRepeat() )
    {
        if (/* PlaybackStatus >= 3 &&*/ RTEventButton->isOn() )
        {
            QString rtn;
            //REAL-TIME ACCELERATORS
            QChar test;
            for ( int n = 0; n < MAXRTEVENTS; n++ )
            {
                if ( RTEvents[n] != NULL )
                {
                    //qDebug("not null %d", n);
                    if ( RTEvents[n]->accel.startsWith("^") )
                    {
                        test = RTEvents[n]->accel.at(1);
                        if ( k->ascii() == test.unicode() )
                        {
                            Error( " -- Real-time event no." + rtn.setNum( n+1, 10 ) + " triggered...\n" );
                            T->ToggleAKeys( true );
                            InterpretCue( RTEvents[n] );
                        }
                    }
                }
            }
        }
    }
}

void RTMix::customEvent( QCustomEvent *e )
{
    //qDebug("Received custom event %d", e->type() );
    if ( e->type() == 2000 )
    {
        //StringEvent goes to Log
        StringEvent* se = (StringEvent*)e;
        //qDebug("String = " + se->string() );
        if ( se->string() == "*" )
        {
            //qDebug("No message");
            //this means no message received
            //TODO
        }
        else if ( se->string().find( "--", 0 ) != -1 )
        {
            Error( se->string() );
        }
        else
        {
            //qDebug("Logging");
            Error( se->string() );
        }
    }
    if ( e->type() == 3000 )
    {
        //Midi event to be parsed
        MidiEvent* me = (MidiEvent*)e;
        //qDebug("Midi message received");
        //qDebug("Values : %d %d %d", me->command(), me->data_1(), me->data_2() );
        T->ToggleAMidi( true );
        ParseRtMidiMessage( me->command(), me->data_1(), me->data_2() );
    }
    if ( e->type() == 10000 )
    {
        LongEvent* le = (LongEvent*) e;
        if( le->val() == 0 )
        {
            UpdateCounter();
            UpdateMetros();

            if ( PlaybackStatus == 3 )
            {
                UpdatePause();
            }
            if ( PlaybackStatus <= 3 && RTEventButton->isOn() )
            {
                A->UpdateCounter();
            }
        }
    }
}

void RTMix::ReceiveKeyPressEvent( QKeyEvent *k )
{
    keyPressEvent( k );
}

void RTMix::ReceiveKeyReleaseEvent( QKeyEvent *k )
{
    keyReleaseEvent( k );
}

void RTMix::HelpMode()
{
	QWhatsThis::enterWhatsThisMode();
}

void RTMix::ToggleMidiLog( bool b )
{
    if ( b )
    {
        Midi->MidiLog = true;
        //ToggleVerbose( TRUE );
        Error( "Midi logging enabled. WARNING: do not use this in performance settings as it may hinder real-time performance." );
    }
    else
    {
        Midi->MidiLog = false;
        //ToggleVerbose( FALSE );
        Error( "Midi logging disabled." );
    }
}

void RTMix::ToggleVerbose( bool b )
{
    if ( b )
    {
        Verbose = true;
        Error( "Verbose Console output enabled. WARNING: do not use this in performance settings as it may hinder real-time performance." );
    }
    else
    {
        Error( "Verbose Console output disabled." );
        Verbose = false;
    }
}

int RTMix::SpawnMidi( QString port )
{
    S->MidiStatus->setText("Status: OK" );
    if ( Midi != NULL )
    {
        MIDIEventButton->setOn( false );
        Midi->RetryOpen( port );
        //Midi->exit();
        //disconnect( MIDIEventButton, SIGNAL ( toggled( bool ) ), 0, 0 );
        //delete Midi;
        //Midi = NULL;
    }
    else
    {
        Midi = new QMidi( this, "midi", 0, port );
        connect ( MIDIEventButton, SIGNAL ( toggled( bool ) ), Midi, SLOT ( ChangeStatus( bool ) ) );
        connect ( MIDIEventButton, SIGNAL ( toggled( bool ) ), T, SLOT ( ToggleMMidi( bool ) ) );
        Midi->start();
    }
    //return Midi->GetStatus();
    return 0;
}

void RTMix::Purge()
{
    T->ToggleAWarns( FALSE );
    T->ToggleAErrors( FALSE );    
    T->Clear();
}

int RTMix::Quit()
{
	if ( outputFile == "0" && Editor->text() != "" || Editor->text() != compareFile ) {
		switch ( QMessageBox::warning ( this, "Quit", "Scriptfile has not been saved since you modified it. Really quit?", "Quit", "Save and Quit", "Cancel", 1, 1) ) {
			case 0:
				this->~RTMix();
				break;
			case 1:
				SaveFile();
				this->~RTMix();
				break;
			case 2:
				return 0;
				break;
		}
	}
	else {
		switch ( QMessageBox::warning ( this, "Quit", "Are you sure?", "Yes", "No", 0, 0, 1) ) {
			case 0:
				this->~RTMix();
				break;
			case 1:
				return 0;
				break;
		}
	}
	return 0;
}

void RTMix::OpenSettings()
{
	int w = RTMix::x() + 138;
	int h = RTMix::y() + 147;
	if ( w < 0 ) { w = 0; }
	if ( h < 0 ) { h = 0; }
	S->move( w, h );
	S->show();
	//S->move( x,y );
	S->setActiveWindow();
	S->raise();
}

void RTMix::OpenConsole()
{
    T->showNormal();
    T->raise();
}

void RTMix::Do_Panic()
{
    Panic( NULL );
}

void RTMix::Do_Play()
{
    Play( NULL );
}

void RTMix::Do_Stop()
{
    Stop( NULL );
}

void RTMix::Do_Pause()
{
    Pause( NULL );
}

#include "rtmix-fileio.h"
#include "rtmix-events.h"
#include "rtmix-parser.h"
#include "rtmix-lightevents.h"
#include "rtmix-timedevents.h"
#include "rtmix-network.h"
