/***************************************************************************
                          settings-cuemethods.h  -  description
                             -------------------
    begin                : Fri Aug 23 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGS_CUEMETHODS_H
#define SETTINGS_CUEMETHODS_H

#include <qaccel.h>
#include <qapplication.h>
#include <qfile.h>
#include <qdir.h>
#include <qtextstream.h>
#include <qmessagebox.h>
#include <warning.h>

void settings::FillDefaultSettings()
{
	int n;

	for ( n = 0; n < 12; n++ )
	{
		Default->Size[n] = false;
	}

	Default->Editor = "/usr/bin/kwrite";
	

	Default->Accel[0] = "CTRL+Up";
	Default->Accel[1] = "CTRL+Space";
	Default->Accel[2] = "CTRL+Left";
	Default->Accel[3] = "CTRL+Right";
	Default->Accel[4] = "CTRL+Down";
	Default->Accel[5] = "CTRL+Return";

	Default->MainPath[0][0] = "/usr/local/rtmix/images/redoff2.png";
	Default->MainPath[1][0] = "/usr/local/rtmix/images/redon2.png";
	Default->MainPath[0][1] = "/usr/local/rtmix/images/yellowoff2.png";
	Default->MainPath[1][1] = "/usr/local/rtmix/images/yellowon2.png";
	Default->MainPath[0][2] = "/usr/local/rtmix/images/greenoff2.png";
	Default->MainPath[1][2]  = "/usr/local/rtmix/images/greenon2.png";

	for ( n = 0; n < 4; n++ )
	{
		Default->NameWarningOff[n] = "/usr/local/rtmix/images/multiled.png";
		Default->NameWarningWarn[n] = "/usr/local/rtmix/images/yellowon2.png";
		Default->NameWarningOn[n] = "/usr/local/rtmix/images/greenon2.png";
	}

	for ( n = 0; n < 4; n++ )
	{
		Default->NameMetroOff[n] = "/usr/local/rtmix/images/redoff2.png";
		Default->NameMetroOn[n] = "/usr/local/rtmix/images/redon2.png";
	}

	for ( n = 0; n < 6; n++ )
	{
		Default->NameLEDwOff[n] = "/usr/local/rtmix/images/multiled.png";
		Default->NameLEDwWarn[n] = "/usr/local/rtmix/images/yellowon2.png";
		Default->NameLEDwOn[n] = "/usr/local/rtmix/images/greenon2.png";
	}

	for ( n = 0; n < 6; n++ )
	{
		Default->LEDColor[n].setRgb(85, 255, 0);
	}
	Default->LEDColor[6].setRgb(255, 0, 0);

	Default->Font[0].setPointSize( 10 ); //main app
	Default->Font[1].setPointSize( 20 ); //notification
	Default->Font[2].setPointSize( 10 ); //editor
	Default->Font[3].setPointSize( 10 ); //error log
	Default->Font[4].setPointSize( 10 ); //warning window
	Default->Font[5].setPointSize( 10 ); //extern LCD
	Default->Font[6].setPointSize( 10 ); //metro
  
	Default->FontColor[0].setRgb(85, 255, 0);
	Default->FontColor[1].setRgb(85, 255, 0);
	Default->FontColor[2].setRgb(255, 255, 255);
	Default->FontColor[3].setRgb(255, 255, 255);	

	Default->WidgetName[0] = "Player 1";
	Default->WidgetName[1] = "Player 2";
	Default->WidgetName[2] = "Player 3";
	Default->WidgetName[3] = "Player 4";
	Default->WidgetName[4] = "Metro 1";
	Default->WidgetName[5] = "Metro 2";
	Default->WidgetName[6] = "Metro 3";
	Default->WidgetName[7] = "Metro 4";
	Default->WidgetName[8] = "LED 1";
	Default->WidgetName[9] = "LED 2";
	Default->WidgetName[10] = "LED 3";
	Default->WidgetName[11] = "LED 4";
	Default->WidgetName[12] = "LED 5";
	Default->WidgetName[13] = "LED 6";	

	Default->MidiPort = "/dev/sequencer";
	Default->NetAuth = "RTMix is here :-)";
	Default->EventFilter = "rm ,shutdown ,cp ,mv ,";
	Default->Browser = "/usr/bin/mozilla";
}


void settings::ReadSettings()
{
	QString s, filePath;
	int n;
	bool ok;

	filePath = QDir::homeDirPath() + "/.rtmix";
	QFile f( filePath );
	if ( f.open(IO_ReadOnly) )
	{
		QTextStream t( &f );

		for ( n = 0; n < 12; n++ )
		{
			s = t.readLine();
			Saved->Size[n] = s.toInt( &ok, 10 );
		}

		s = t.readLine();
		Saved->Editor = s.simplifyWhiteSpace();
		
		for ( n = 0; n < 6; n++ )
		{
			Saved->Accel[n] = t.readLine();
		}

		for ( n = 0; n < 3; n++ )
		{
			Saved->MainPath[0][n] = t.readLine();
			Saved->MainPath[1][n] = t.readLine();			
		}

		for ( n = 0; n < 4; n++ )
		{
			Saved->NameWarningOff[n] = t.readLine();
			Saved->NameWarningWarn[n] = t.readLine();			
			Saved->NameWarningOn[n] = t.readLine();			
		}

		for ( n = 0; n < 4; n++ )
		{
			Saved->NameMetroOff[n] = t.readLine();
			Saved->NameMetroOn[n] = t.readLine();
		}

		for ( n = 0; n < 6; n++ )
		{
			Saved->NameLEDwOff[n] = t.readLine();
			Saved->NameLEDwWarn[n] = t.readLine();			
			Saved->NameLEDwOn[n] = t.readLine();			
		}

		for ( n = 0; n < 7; n++ )
		{
			Saved->LEDColor[n].setNamedColor( "#" + t.readLine() );
		}

		for ( n=0; n < 7; n++ )
		{
			Saved->Font[n].setFamily( t.readLine() );
			s = t.readLine();
			Saved->Font[n].setPointSize(s.toInt( &ok, 10 ));
			s = t.readLine();
			Saved->Font[n].setWeight(s.toInt( &ok, 10 ));
			s = t.readLine();
			Saved->Font[n].setItalic(s.toInt( &ok, 10 ));
		}

		for ( n=0; n < 4; n++ )
		{
			Saved->FontColor[n].setNamedColor( "#" + t.readLine() );
		}

		for ( n=0; n < 14; n++ )
		{
			Saved->WidgetName[n] = t.readLine();
		}
		
		Saved->MidiPort = t.readLine();
		Saved->NetAuth = t.readLine();
		Saved->EventFilter = t.readLine();
		Saved->Browser = t.readLine();
                
		f.close();
		*Current = *Saved;
		UpdateWidgets( 0 );	
	}
	else
	{
		*Current = *Default;
		*Saved = *Default;
		UpdateWidgets( 0 );
	}
}

void settings::WriteSettings( struct settingscue *SC )
{
  QString s, filePath;
  int n, c;

  filePath = QDir::homeDirPath() + "/.rtmix";
  QFile f( filePath );
  if ( f.open(IO_WriteOnly) )
  {
      s.setNum( SC->Size[0], 10 ) + "\n";
      f.writeBlock( s, strlen(s) );
      f.writeBlock( "\n", 1 );
      for ( n = 1; n < 12; n++ )
      {
          f.writeBlock( s.setNum( SC->Size[n], 10 ) + "\n", strlen(s) + 1 );
      }

      s = SC->Editor + "\n";
      f.writeBlock( s, strlen(s) );
    
      for ( n = 0; n < 6; n++ )
      {
          s = SC->Accel[n] + "\n";
          f.writeBlock( s, strlen(s) );
      }

      for ( n = 0; n < 3; n++ )
      {
          f.writeBlock( SC->MainPath[0][n] + "\n", strlen(SC->MainPath[0][n]) + 1 );
          f.writeBlock( SC->MainPath[1][n] + "\n", strlen(SC->MainPath[1][n]) + 1 );
      }

		for ( n = 0; n < 4; n++ )
		{
			f.writeBlock( SC->NameWarningOff[n] + "\n", strlen( SC->NameWarningOff[n] ) + 1 );
			f.writeBlock( SC->NameWarningWarn[n] + "\n", strlen( SC->NameWarningWarn[n] ) + 1 );
			f.writeBlock( SC->NameWarningOn[n] + "\n", strlen( SC->NameWarningOn[n] ) + 1 );   	
		}

		for ( n = 0; n < 4; n++ )
		{
			f.writeBlock( SC->NameMetroOff[n] + "\n", strlen( SC->NameMetroOff[n] ) + 1 );
			f.writeBlock( SC->NameMetroOn[n] + "\n", strlen( SC->NameMetroOn[n] ) + 1 );
		}

		for ( n = 0; n < 6; n++ )
		{
			f.writeBlock( SC->NameLEDwOff[n] + "\n", strlen( SC->NameLEDwOff[n] ) + 1 );
			f.writeBlock( SC->NameLEDwWarn[n] + "\n", strlen( SC->NameLEDwWarn[n] ) + 1 );
			f.writeBlock( SC->NameLEDwOn[n] + "\n", strlen( SC->NameLEDwOn[n] ) + 1 );
		}

		for ( n = 0; n < 7; n++ )
		{
			c = SC->LEDColor[n].rgb() - 0xff000000;
			s.setNum( c, 16 );
			f.writeBlock( s + "\n", strlen( s ) + 1 );
		}

		for ( n=0; n < 7; n++ )
		{
			s = SC->Font[n].family();
			f.writeBlock( s + "\n", strlen( s ) + 1 );
			s.setNum(SC->Font[n].pointSize(), 10);
			f.writeBlock( s + "\n", strlen( s ) + 1 );
			s.setNum(SC->Font[n].weight(), 10);
			f.writeBlock( s + "\n", strlen( s ) + 1 );
			s.setNum(SC->Font[n].italic(), 10);
			f.writeBlock( s + "\n", strlen( s ) + 1 );	
		}

		for ( n=0; n < 4; n++ )
		{
			c = SC->FontColor[n].rgb() - 0xff000000;
			s.setNum( c, 16 );
			while (s.length() < 6 )
			{
              s = "0" + s;	
			}
			f.writeBlock( s + "\n", strlen( s ) + 1 );	
		}

		for ( n=0; n < 14; n++ )
		{
			f.writeBlock( SC->WidgetName[n] + "\n", strlen( SC->WidgetName[n]  ) + 1 );	
		}

		f.writeBlock( SC->MidiPort + "\n", strlen( SC->MidiPort ) + 1 );
		f.writeBlock( SC->NetAuth + "\n", strlen( SC->NetAuth ) + 1 );
		f.writeBlock( SC->EventFilter + "\n", strlen( SC->EventFilter ) + 1 );
		f.writeBlock( SC->Browser + "\n", strlen( SC->Browser ) + 1 );
        
		f.close();
		if ( SaveSettingsButton->hasFocus() )
		{
			QMessageBox::information( this, "Settings Saved", "Settings successfully saved into the " + filePath + " file." );
		}
	}
	else
	{
		if ( SaveSettingsButton->hasFocus() )
     	{
			QMessageBox::critical( this, "Error", "Your settings could not be saved because\nthe file " + filePath + " could not be accessed.\nPlease check that you have write-permissions to this file." );
		}
	}	
}


//MAIN METHOD RESPONSIBLE FOR CHANGING VALUES
void settings::UpdateWidgets( int i )
{
	settingscue *left, *right;
	int TempSize[12];
	int n, load;
	QString s, temp;

	if ( !i )
	{
		load = 0;
		R->Sp->UpdateSplash( load++, "Configuring Settings" );
		left = Current;
     	right = Default;
	}

	if ( i == 1 )
	{
		left = Default;
     	right = Current;
	}
	if ( i == 2 )
	{
		left = Current;
		right = Saved;
	}
	if ( i == 3 )
	{
		left = Saved;
		right = Current;
	}


	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Editor Settings" ); }	

	if ( !i || left->Editor != right->Editor )
	{
		ExternalEditorLineEdit->setText( left->Editor );
	}
	
	if ( i != 1 )
	{
    	if ( !i ) { 	R->Sp->UpdateSplash( load++, "Loading Keyboard Accelerators" ); }	

    	if ( !i || left->Accel[0] != right->Accel[0] )
    	{
    		R->PlayButton->setAccel ( QAccel::stringToKey( left->Accel[0] ) );
    	}
    	
    	if ( !i || left->Accel[1] != right->Accel[1] )
    	{
    		R->PauseButton->setAccel ( QAccel::stringToKey( left->Accel[1] ) );
    	}
    	
    	if ( !i || left->Accel[2] != right->Accel[2] )
    	{
    		R->RewindButton->setAccel ( QAccel::stringToKey( left->Accel[2] ) );
    	}
    	
    	if ( !i || left->Accel[3] != right->Accel[3] )
    	{
    		R->FForwardButton->setAccel ( QAccel::stringToKey( left->Accel[3] ) );
    	}
    	
    	if ( !i || left->Accel[4] != right->Accel[4] )
    	{
    		R->StopButton->setAccel ( QAccel::stringToKey( left->Accel[4] ) );
    	}
    	
    	if ( !i || left->Accel[5] != right->Accel[5] )
    	{
    		R->PanicButton->setAccel ( QAccel::stringToKey( left->Accel[5] ) );
    	}


    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Main Interface Visuals" );  }

    	if ( !i || left->MainPath[0][0] != right->MainPath[0][0] )
    	{
    		R->imageRedoff.load( left->MainPath[0][0], NULL, DiffuseAlphaDither);
    		R->PlayIndicator->setPixmap( R->imageRedoff );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }    	

    	if ( !i || left->MainPath[1][0] != right->MainPath[1][0] )
    	{
    		R->imageRedon.load( left-> MainPath[1][0], NULL, DiffuseAlphaDither);;
    	}   	
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }

    	if ( !i || left->MainPath[0][1] != right->MainPath[0][1] )
    	{
    		R->imageYellowoff.load( left->MainPath[0][1], NULL, DiffuseAlphaDither);
    		R->WarnIndicator->setPixmap( R->imageYellowoff );
    	}    	
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }

    	if ( !i || left->MainPath[1][1] != right->MainPath[1][1] )
    	{
    		R->imageYellowon.load( left-> MainPath[1][1], NULL, DiffuseAlphaDither);;
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }      	

    	if ( !i || left->MainPath[0][2] != right->MainPath[0][2] )
    	{
    		R->imageGreenoff.load( left->MainPath[0][2], NULL, DiffuseAlphaDither);
    		R->WarnExecute->setPixmap( R->imageGreenoff );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }      	

    	if ( !i || left->MainPath[1][2] != right->MainPath[1][2] )
    	{
    		R->imageGreenon.load( left-> MainPath[1][2], NULL, DiffuseAlphaDither);;
    	}    	

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Warning Interface Visuals" );  }

    	if ( !i || left->NameWarningOff[0] != right->NameWarningOff[0] )
    	{
    		R->Window1->SetImage( left->NameWarningOff[0], 0 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningWarn[0] != right->NameWarningWarn[0] )
    	{
    		R->Window1->SetImage( left->NameWarningWarn[0], 1 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOn[0] != right->NameWarningOn[0] )
    	{
    		R->Window1->SetImage( left->NameWarningOn[0], 2 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOff[1] != right->NameWarningOff[1] )
    	{
			if ( left->NameWarningOff[1] == left->NameWarningOff[0] )
			{
				*R->Window2->LED = *R->Window1->LED;
				R->Window2->WarnLED->setPixmap( *R->Window2->LED );
			}
			else
			{
    			R->Window2->SetImage( left->NameWarningOff[1], 0 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningWarn[1] != right->NameWarningWarn[1] )
    	{
			if ( left->NameWarningWarn[1] == left->NameWarningWarn[0] )
			{
             	*R->Window2->LEDYellow = *R->Window1->LEDYellow;
			}
			else
			{
    			R->Window2->SetImage( left->NameWarningWarn[1], 1 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOn[1] != right->NameWarningOn[1] )
    	{
			if ( left->NameWarningWarn[1] == left->NameWarningWarn[0] )
			{
             	*R->Window2->LEDGreen = *R->Window1->LEDGreen;
			}
			else
			{
    			R->Window2->SetImage( left->NameWarningOn[1], 2 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOff[2] != right->NameWarningOff[2] )
    	{
			if ( left->NameWarningOff[2] == left->NameWarningOff[0] )
			{
             	*R->Window3->LED = *R->Window1->LED;
				R->Window3->WarnLED->setPixmap( *R->Window3->LED );
			}
			else
			{
    			R->Window3->SetImage( left->NameWarningOff[2], 0 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningWarn[2] != right->NameWarningWarn[2] )
    	{
			if ( left->NameWarningWarn[2] == left->NameWarningWarn[0] )
			{
             	*R->Window3->LEDYellow = *R->Window1->LEDYellow;
			}
			else
			{
    			R->Window3->SetImage( left->NameWarningWarn[2], 1 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOn[2] != right->NameWarningOn[2] )
    	{
			if ( left->NameWarningWarn[2] == left->NameWarningWarn[0] )
			{
             	*R->Window3->LEDGreen = *R->Window1->LEDGreen;
			}
			else
			{
    			R->Window3->SetImage( left->NameWarningOn[2], 2 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOff[3] != right->NameWarningOff[3] )
    	{
			if ( left->NameWarningOff[3] == left->NameWarningOff[0] )
			{
             	*R->Window4->LED = *R->Window1->LED;
				R->Window4->WarnLED->setPixmap( *R->Window4->LED );
			}
			else
			{
	    		R->Window4->SetImage( left->NameWarningOff[3], 0 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningWarn[3] != right->NameWarningWarn[3] )
    	{
			if ( left->NameWarningWarn[3] == left->NameWarningWarn[0] )
			{
             	*R->Window4->LEDYellow = *R->Window1->LEDYellow;
			}
			else
			{
    			R->Window4->SetImage( left->NameWarningWarn[3], 1 );
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameWarningOn[3] != right->NameWarningOn[3] )
    	{
			if ( left->NameWarningWarn[3] == left->NameWarningWarn[0] )
			{
             	*R->Window4->LEDGreen = *R->Window1->LEDGreen;
			}
			else
			{
	    		R->Window4->SetImage( left->NameWarningOn[3], 2 );
			}
    	}	

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Metro Interface Visuals" );  }

    	if ( !i || left->NameMetroOff[0] != right->NameMetroOff[0] )
    	{
    		R->Metro1->SetImage( left->NameMetroOff[0], 0 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOn[0] != right->NameMetroOn[0] )
    	{
    		R->Metro1->SetImage( left->NameMetroOn[0], 1 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOff[1] != right->NameMetroOff[1] )
    	{
    		R->Metro2->SetImage( left->NameMetroOff[1], 0 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOn[1] != right->NameMetroOn[1] )
    	{
    		R->Metro2->SetImage( left->NameMetroOn[1], 1 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOff[2] != right->NameMetroOff[2] )
    	{
    		R->Metro3->SetImage( left->NameMetroOff[2], 0 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOn[2] != right->NameMetroOn[2] )
    	{
    		R->Metro3->SetImage( left->NameMetroOn[2], 1 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOff[3] != right->NameMetroOff[3] )
    	{
    		R->Metro4->SetImage( left->NameMetroOff[3], 0 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameMetroOn[3] != right->NameMetroOn[3] )
    	{
    		R->Metro4->SetImage( left->NameMetroOn[3], 1 );
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading LED Interface Visuals" );  }
    	
    	if ( !i || left->NameLEDwOff[0] != right->NameLEDwOff[0] )
    	{
         	R->LEDw->SetImage( left->NameLEDwOff[0], 0, 0);
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }    	

    	if ( !i || left->NameLEDwWarn[0] != right->NameLEDwWarn[0] )
    	{
         	R->LEDw->SetImage( left->NameLEDwWarn[0], 1, 0);
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[0] != right->NameLEDwOn[0] )
    	{
         	R->LEDw->SetImage( left->NameLEDwOn[0], 2, 0);
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOff[1] != right->NameLEDwOff[1] )
    	{
			if ( left->NameLEDwOff[1] == left->NameLEDwOff[0] )
			{
             	*R->LEDw->LED2 = *R->LEDw->LED1;
				R->LEDw->PixmapLED2->setPixmap( *R->LEDw->LED2 );
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOff[1], 0, 1);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwWarn[1] != right->NameLEDwWarn[1] )
    	{
			if ( left->NameLEDwWarn[1] == left->NameLEDwWarn[0] )
			{
             	*R->LEDw->LED2Yellow = *R->LEDw->LED1Yellow;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwWarn[1], 1, 1);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[1] != right->NameLEDwOn[1] )
    	{
			if ( left->NameLEDwOn[1] == left->NameLEDwOn[0] )
			{
             	*R->LEDw->LED2Green = *R->LEDw->LED1Green;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOn[0], 2, 1);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOff[2] != right->NameLEDwOff[2] )
    	{
			if ( left->NameLEDwOff[2] == left->NameLEDwOff[0] )
			{
             	*R->LEDw->LED3 = *R->LEDw->LED1;
				R->LEDw->PixmapLED3->setPixmap( *R->LEDw->LED3 );
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOff[2], 0, 2);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwWarn[2] != right->NameLEDwWarn[2] )
    	{
			if ( left->NameLEDwWarn[2] == left->NameLEDwWarn[0] )
			{
             	*R->LEDw->LED3Yellow = *R->LEDw->LED1Yellow;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwWarn[2], 1, 2);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[2] != right->NameLEDwOn[2] )
    	{
			if ( left->NameLEDwOn[2] == left->NameLEDwOn[0] )
			{
             	*R->LEDw->LED3Green = *R->LEDw->LED1Green;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOn[0], 2, 2);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOff[3] != right->NameLEDwOff[3] )
    	{
			if ( left->NameLEDwOff[3] == left->NameLEDwOff[0] )
			{
             	*R->LEDw->LED4 = *R->LEDw->LED1;
				R->LEDw->PixmapLED4->setPixmap( *R->LEDw->LED4 );
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOff[3], 0, 3);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwWarn[3] != right->NameLEDwWarn[3] )
    	{
			if ( left->NameLEDwWarn[3] == left->NameLEDwWarn[0] )
			{
             	*R->LEDw->LED4Yellow = *R->LEDw->LED1Yellow;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwWarn[3], 1, 3);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[3] != right->NameLEDwOn[3] )
    	{
			if ( left->NameLEDwOn[3] == left->NameLEDwOn[0] )
			{
             	*R->LEDw->LED4Green = *R->LEDw->LED1Green;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOn[0], 2, 3);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOff[4] != right->NameLEDwOff[4] )
    	{
			if ( left->NameLEDwOff[4] == left->NameLEDwOff[0] )
			{
             	*R->LEDw->LED5 = *R->LEDw->LED1;
				R->LEDw->PixmapLED5->setPixmap( *R->LEDw->LED5 );
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOff[4], 0, 4);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwWarn[4] != right->NameLEDwWarn[4] )
    	{
			if ( left->NameLEDwWarn[4] == left->NameLEDwWarn[0] )
			{
             	*R->LEDw->LED5Yellow = *R->LEDw->LED1Yellow;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwWarn[4], 1, 4);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[4] != right->NameLEDwOn[4] )
    	{
			if ( left->NameLEDwOn[4] == left->NameLEDwOn[0] )
			{
             	*R->LEDw->LED5Green = *R->LEDw->LED1Green;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOn[0], 2, 4);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOff[5] != right->NameLEDwOff[5] )
    	{
			if ( left->NameLEDwOff[5] == left->NameLEDwOff[0] )
			{
             	*R->LEDw->LED6 = *R->LEDw->LED1;
				R->LEDw->PixmapLED6->setPixmap( *R->LEDw->LED6 );
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOff[5], 0, 5);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwWarn[5] != right->NameLEDwWarn[5] )
    	{
			if ( left->NameLEDwWarn[5] == left->NameLEDwWarn[0] )
			{
             	*R->LEDw->LED6Yellow = *R->LEDw->LED1Yellow;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwWarn[5], 1, 5);
			}
    	}
    	if ( !i ) { R->Sp->UpdateSplash( load++, "" );  }     	

    	if ( !i || left->NameLEDwOn[5] != right->NameLEDwOn[5] )
    	{
			if ( left->NameLEDwOn[5] == left->NameLEDwOn[0] )
			{
             	*R->LEDw->LED6Green = *R->LEDw->LED1Green;
			}
			else
			{
         		R->LEDw->SetImage( left->NameLEDwOn[0], 2, 5);
			}
    	}   	

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Timer Colors" );  }

    	if ( !i || left->LEDColor[0] != right->LEDColor[0] )
    	{
        	R->cgTime.setColor( QColorGroup::Foreground, left->LEDColor[0] );
        	R->cgTime.setColor( QColorGroup::Button, left->LEDColor[0] );
        	R->cgTime.setColor( QColorGroup::Light, left->LEDColor[0].light(150) );
        	R->cgTime.setColor( QColorGroup::Midlight, left->LEDColor[0].light(125) );
        	R->cgTime.setColor( QColorGroup::Dark, left->LEDColor[0].light(50)  );
        	R->cgTime.setColor( QColorGroup::Mid, left->LEDColor[0].light(66) );
        	R->palTime.setActive( R->cgTime );
        	R->palTime.setInactive( R->cgTime );
        	R->palTime.setDisabled( R->cgTime );
        	R->NSecond->setPalette( R->palTime );
        	R->NTenSecond->setPalette( R->palTime );
        	R->NCentisecond->setPalette( R->palTime );
        	R->NTenCentisecond->setPalette( R->palTime );
        	R->NHour->setPalette( R->palTime );
        	R->NMinute->setPalette( R->palTime );
        	R->NTenMinute->setPalette( R->palTime );
    		R->HourMinuteColumn->setPalette( R->palTime );
        	R->MinuteSecondColumn->setPalette( R->palTime );
        	R->SecondCentisecondDot->setPalette( R->palTime );

			R->E->cg = R->cgTime;

        	R->E->pal.setActive( R->E->cg );
        	R->E->pal.setInactive( R->E->cg );
        	R->E->pal.setDisabled( R->E->cg );
        	R->E->NSecond->setPalette( R->E->pal );
        	R->E->NTenSecond->setPalette( R->E->pal );
        	R->E->NCentisecond->setPalette( R->E->pal );
        	R->E->NTenCentisecond->setPalette( R->E->pal );
        	R->E->NHour->setPalette( R->E->pal );
        	R->E->NMinute->setPalette( R->E->pal );
        	R->E->NTenMinute->setPalette( R->E->pal );
    		R->E->HourMinuteColumn->setPalette( R->E->pal );
        	R->E->MinuteSecondColumn->setPalette( R->E->pal );
        	R->E->SecondCentisecondDot->setPalette( R->E->pal );
        }
    	

    	if ( !i || left->LEDColor[1] != right->LEDColor[1] )
    	{	
        	R->cgWarn.setColor( QColorGroup::Foreground, left->LEDColor[1] );
        	R->cgWarn.setColor( QColorGroup::Button, left->LEDColor[1] );
    		R->cgWarn.setColor( QColorGroup::Light, left->LEDColor[1].light(150) );
        	R->cgWarn.setColor( QColorGroup::Midlight, left->LEDColor[1].light(125) );
        	R->cgWarn.setColor( QColorGroup::Dark, left->LEDColor[1].light(50)  );
        	R->cgWarn.setColor( QColorGroup::Mid, left->LEDColor[1].light(66) );
        	R->palWarn.setActive( R->cgWarn );
        	R->palWarn.setInactive( R->cgWarn );
        	R->palWarn.setDisabled( R->cgWarn );
        	R->NWarnTenMinute->setPalette( R->palWarn );
        	R->NWarnMinute->setPalette( R->palWarn );
        	R->NWarnTenSecond->setPalette( R->palWarn );
        	R->NWarnSecond->setPalette( R->palWarn );
        	R->NWarnTenCentisecond->setPalette( R->palWarn );
        	R->NWarnCentisecond->setPalette( R->palWarn );
        	R->WarnMinuteSecondColumn->setPalette( R->palWarn );
        	R->WarnSecondCentisecondDot->setPalette( R->palWarn );
        }
    	

    	if ( !i || left->LEDColor[2] != right->LEDColor[2] )
    	{
        	R->Window1->cg.setColor( QColorGroup::Foreground, left->LEDColor[2] );
        	R->Window1->cg.setColor( QColorGroup::Button, left->LEDColor[2] );
    		R->Window1->cg.setColor( QColorGroup::Light, left->LEDColor[2].light(150) );
        	R->Window1->cg.setColor( QColorGroup::Midlight, left->LEDColor[2].light(125) );
        	R->Window1->cg.setColor( QColorGroup::Dark, left->LEDColor[2].light(50)  );
        	R->Window1->cg.setColor( QColorGroup::Mid, left->LEDColor[2].light(66) );
        	R->Window1->pal.setActive( R->Window1->cg );
        	R->Window1->pal.setInactive( R->Window1->cg );
        	R->Window1->pal.setDisabled( R->Window1->cg );
    		R->Window1->NTime->setPalette( R->Window1->pal );
        }
    	

    	if ( !i || left->LEDColor[3] != right->LEDColor[3] )
    	{
        	R->Window2->cg.setColor( QColorGroup::Foreground, left->LEDColor[3] );
        	R->Window2->cg.setColor( QColorGroup::Button, left->LEDColor[3] );
    		R->Window2->cg.setColor( QColorGroup::Light, left->LEDColor[3].light(150) );
        	R->Window2->cg.setColor( QColorGroup::Midlight, left->LEDColor[3].light(125) );
        	R->Window2->cg.setColor( QColorGroup::Dark, left->LEDColor[3].light(50)  );
        	R->Window2->cg.setColor( QColorGroup::Mid, left->LEDColor[3].light(66) );
        	R->Window2->pal.setActive( R->Window2->cg );
        	R->Window2->pal.setInactive( R->Window2->cg );
        	R->Window2->pal.setDisabled( R->Window2->cg );
    		R->Window2->NTime->setPalette( R->Window2->pal );
        }
    	

    	if ( !i || left->LEDColor[4] != right->LEDColor[4] )
    	{
        	R->Window3->cg.setColor( QColorGroup::Foreground, left->LEDColor[4] );
        	R->Window3->cg.setColor( QColorGroup::Button, left->LEDColor[4] );
    		R->Window3->cg.setColor( QColorGroup::Light, left->LEDColor[4].light(150) );
        	R->Window3->cg.setColor( QColorGroup::Midlight, left->LEDColor[4].light(125) );
        	R->Window3->cg.setColor( QColorGroup::Dark, left->LEDColor[4].light(50)  );
        	R->Window3->cg.setColor( QColorGroup::Mid, left->LEDColor[4].light(66) );
        	R->Window3->pal.setActive( R->Window3->cg );
        	R->Window3->pal.setInactive( R->Window3->cg );
        	R->Window3->pal.setDisabled( R->Window3->cg );
    		R->Window3->NTime->setPalette( R->Window3->pal );
    	}
    	

    	if ( !i || left->LEDColor[5] != right->LEDColor[5] )
    	{
        	R->Window4->cg.setColor( QColorGroup::Foreground, left->LEDColor[5] );
        	R->Window4->cg.setColor( QColorGroup::Button, left->LEDColor[5] );
    		R->Window4->cg.setColor( QColorGroup::Light, left->LEDColor[5].light(150) );
        	R->Window4->cg.setColor( QColorGroup::Midlight, left->LEDColor[5].light(125) );
        	R->Window4->cg.setColor( QColorGroup::Dark, left->LEDColor[5].light(50)  );
        	R->Window4->cg.setColor( QColorGroup::Mid, left->LEDColor[5].light(66) );
    	   	R->Window4->pal.setActive( R->Window4->cg );
        	R->Window4->pal.setInactive( R->Window4->cg );
        	R->Window4->pal.setDisabled( R->Window4->cg );
    		R->Window4->NTime->setPalette( R->Window4->pal );
    	}

    	if ( !i || left->LEDColor[6] != right->LEDColor[6] )
    	{
    	    R->A->cg.setColor( QColorGroup::Foreground, left->LEDColor[6] );
       	R->A->cg.setColor( QColorGroup::Button, left->LEDColor[6] );
    		R->A->cg.setColor( QColorGroup::Light, left->LEDColor[6].light(150) );
        	R->A->cg.setColor( QColorGroup::Midlight, left->LEDColor[6].light(125) );
        	R->A->cg.setColor( QColorGroup::Dark, left->LEDColor[6].light(50)  );
        	R->A->cg.setColor( QColorGroup::Mid, left->LEDColor[6].light(66) );

        	R->A->pal.setActive( R->A->cg );
        	R->A->pal.setInactive( R->A->cg );
        	R->A->pal.setDisabled( R->A->cg );
        	R->A->NSecond->setPalette( R->A->pal );
        	R->A->NTenSecond->setPalette( R->A->pal );
        	R->A->NCentisecond->setPalette( R->A->pal );
        	R->A->NTenCentisecond->setPalette( R->A->pal );
        	R->A->NHour->setPalette( R->A->pal );
        	R->A->NMinute->setPalette( R->A->pal );
        	R->A->NTenMinute->setPalette( R->A->pal );
    		R->A->HourMinuteColumn->setPalette( R->A->pal );
        	R->A->MinuteSecondColumn->setPalette( R->A->pal );
        	R->A->SecondCentisecondDot->setPalette( R->A->pal );
        }

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Fonts" );  }     	

    	if ( !i || left->Font[0] != right->Font[0] )
    	{
          QApplication::setFont( left->Font[0], TRUE );
    	}
    	

    	if ( !i || left->Font[1] != right->Font[1] )
    	{
         	R->TextInterface->setFont( left->Font[1] );
    	}
    	

    	if ( !i || left->Font[2] != right->Font[2] )
    	{
         	R->Editor->setFont( left->Font[2] );
    	}
    	

    	if ( !i || left->Font[3] != right->Font[3] )
    	{
         	R->T->MultiLineEdit->setFont( left->Font[3] );
    	}
    	

    	if ( !i || left->Font[4] != right->Font[4] )
    	{
         	R->Window1->WindowLabel->setFont( left->Font[4] );
         	R->Window2->WindowLabel->setFont( left->Font[4] );
         	R->Window3->WindowLabel->setFont( left->Font[4] );
         	R->Window4->WindowLabel->setFont( left->Font[4] );
    	}
    	

    	if ( !i || left->Font[5] != right->Font[5] )
    	{
         	R->LEDw->TextLabel1->setFont( left->Font[5] );
         	R->LEDw->TextLabel2->setFont( left->Font[5] );
         	R->LEDw->TextLabel3->setFont( left->Font[5] );
         	R->LEDw->TextLabel4->setFont( left->Font[5] );
         	R->LEDw->TextLabel5->setFont( left->Font[5] );
         	R->LEDw->TextLabel6->setFont( left->Font[5] );
    	}

    	if ( !i || left->Font[6] != right->Font[6] )
    	{
         	R->Metro1->WindowLabel->setFont( left->Font[6] );
         	R->Metro2->WindowLabel->setFont( left->Font[6] );
         	R->Metro3->WindowLabel->setFont( left->Font[6] );
         	R->Metro4->WindowLabel->setFont( left->Font[6] );
    	}	

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Font Colors" );  }

    	if ( left->FontColor[0] != right->FontColor[0] )
    	{
    		n = left->FontColor[0].red();
    		temp.setNum( n , 16 );
    		if ( temp.length() < 2 )
    		{
             	temp = "0" + temp;
    		}
    		s = temp;

    		n = left->FontColor[0].green();
    		temp.setNum( n , 16 );
    		if ( temp.length() < 2 )
    		{
             	temp = "0" + temp;
    		}
    		s = s + temp;

    		n = left->FontColor[0].blue();
    		temp.setNum( n , 16 );
    		if ( temp.length() < 2 )
    		{
             	temp = "0" + temp;
    		}
    		s = s + temp;
    		
        	R->DefaultTextInterfaceColor = s;

    		R->cgText.setColor( QColorGroup::Text, left->FontColor[0] );
    		R->palText.setActive( R->cgText );
    		R->palText.setInactive( R->cgText );
    		R->palText.setDisabled( R->cgText );
    		R->TextInterface->setPalette( R->palText );
    	}
    	

    	if ( left->FontColor[1] != right->FontColor[1] )
    	{
         	R->cgEdit.setColor( QColorGroup::Text, left->FontColor[1] );
    		R->palEdit.setActive( R->cgEdit );
    		R->palEdit.setInactive( R->cgEdit );
    		R->palEdit.setDisabled( R->cgEdit );
    		R->Editor->setPalette( R->palEdit );
    	}

    	if ( left->FontColor[2] != right->FontColor[2] )
    	{
         	R->T->cg.setColor( QColorGroup::Text, left->FontColor[3] );
    		R->T->pal.setActive( R->T->cg );
    		R->T->pal.setInactive( R->T->cg);
    		R->T->pal.setDisabled( R->T->cg );
    		R->T->MultiLineEdit->setPalette( R->T->pal );
    	}

    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Widget Names" );  }

    	if ( left->WidgetName[0] != right->WidgetName[0] )
    	{
    		R->Window1->SetName( "", left->WidgetName[0] );
    	}
    	

    	if ( left->WidgetName[1] != right->WidgetName[1] )
    	{
    		R->Window2->SetName( "", left->WidgetName[1] );
    	}
    	

    	if ( left->WidgetName[2] != right->WidgetName[2] )
    	{
    		R->Window3->SetName( "", left->WidgetName[2] );
    	}
    	

    	if ( left->WidgetName[3] != right->WidgetName[3] )
    	{
    		R->Window4->SetName( "", left->WidgetName[3] );
    	}
    	

    	if ( left->WidgetName[4] != right->WidgetName[4] )
    	{
    		R->Metro1->UpdateName( "", left->WidgetName[4] );
    	}
    	

    	if ( left->WidgetName[5] != right->WidgetName[5] )
    	{
    		R->Metro2->UpdateName( "", left->WidgetName[5] );
    	}
    	

    	if ( left->WidgetName[6] != right->WidgetName[6] )
    	{
    		R->Metro3->UpdateName( "", left->WidgetName[6] );
    	}
    	

    	if ( left->WidgetName[7] != right->WidgetName[7] )
    	{
    		R->Metro4->UpdateName( "", left->WidgetName[7] );
    	}
    	

    	for ( n = 8; n < 14; n++ )
    	{
    		if ( left->WidgetName[n] != right->WidgetName[n] )
    		{
    			R->LEDw->SetName( n-8, left->WidgetName[n] );
    		}		
    	}
 	}

    if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Default MIDI Port" );  }

	if ( !i || left->MidiPort != right->MidiPort )
	{
     	MidiPortEdit->setText( left->MidiPort );
	}
	
	if ( i != 1 && i != 3 )
	{
    	if ( !i ) { R->Sp->UpdateSplash( load++, "Loading Window Statuses" );  }
		if ( !i || left->Size[9] != right->Size[9] )
		{
			R->ToggleSize( left->Size[9] );
			setWinSize( left->Size[9] );
		}
	}

	if (!i) {
    	int w=R->Sp->x() - 260;
    	int h=R->Sp->y() - 219;
		if ( w < 0 ) { w = 0; }
		if ( h < 0 ) { h = 0; }
		R->move( w, h );
		R->lower();
		R->show();
		R->Sp->raise();
	}

	if ( i < 1 )
	{
    	if ( !i || left->Size[0] != right->Size[0] )
    	{
    		Window1CheckBox->setChecked( left->Size[0] );
    	}
    	if ( !i || left->Size[1] != right->Size[1] )
    	{
    		Window2CheckBox->setChecked( left->Size[1] );
    	}
    	if ( !i || left->Size[2] != right->Size[2] )
    	{
    		Window3CheckBox->setChecked( left->Size[2] );
    	}
    	if ( !i || left->Size[3] != right->Size[3] )
    	{
    		Window4CheckBox->setChecked( left->Size[3] );
    	}
    	if ( !i || left->Size[4] != right->Size[4] )
    	{
    		Metro1CheckBox->setChecked( left->Size[4] );
    	}
    	if ( !i || left->Size[5] != right->Size[5] )
    	{
    		Metro2CheckBox->setChecked( left->Size[5] );
    	}
    	if ( !i || left->Size[6] != right->Size[6] )
    	{
    		Metro3CheckBox->setChecked( left->Size[6] );
    	}
    	if ( !i || left->Size[7] != right->Size[7] )
    	{
    		Metro4CheckBox->setChecked( left->Size[7] );
    	}
    	if ( !i || left->Size[8] != right->Size[8] )
    	{
    		LEDWindowCheckBox->setChecked( left->Size[8] );
    	}
    	if ( !i || left->Size[10] != right->Size[10] )
    	{
    		ToggleTimer( left->Size[10] );
    	}
    	if ( !i || left->Size[11] != right->Size[11] )
    	{
    		ToggleAbsTimer( left->Size[11] );
    	}
	}

    //Network stuff
    if ( !i || left->NetAuth != right->NetAuth )
    {
        NetAuthEdit->setText( left->NetAuth );
    }
    //Filter stuff
    if ( !i || left->EventFilter != right->EventFilter )
    {
        Filter->setText( left->EventFilter );
    }
    //Browser stuff
    if ( !i || left->Browser != right->Browser )
    {
        BrowserLineEdit->setText( left->Browser );
    }      
    //if defaults are called, make sure that the window toggles are not affected
    if ( i > 0 )
    {
        for ( n = 0; n < 12; n++ )
        {
            TempSize[n] = right->Size[n];
        }
    }

   ///////////////////////////////////////////////////////////////////////////////////
                     
    if ( i > 0 ) { *right = *left; } //COPY THE CUE

    if ( i > 0 )
    {
        for ( n = 0; n < 12; n++ )
        {
            right->Size[n] = TempSize[n];
        }
    }
    if ( !i ) { R->Sp->UpdateSplash( load++, "Doing Final Adjustments" );  }

    AdjustShortcut( ShortcutComboBox->currentItem() );
    AdjustPixmap( PixmapComboBox->currentItem() );
    AdjustPreviewLCD( TimerComboBox->currentItem() );
    AdjustFont( FontGroup->id( FontGroup->selected() ) );
    AdjustName( TextComboBox->currentItem() );
    //R->T->show();
}

#endif

