/***************************************************************************
                          settings-fonts.h  -  description
                             -------------------
    begin                : Fri Aug 30 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qfontdialog.h>

void settings::SelectFont()
{
    int n;
    bool ok;

    n = FontGroup->id( FontGroup->selected() );
    QFont f = QFontDialog::getFont( &ok, Current->Font[n], this, "Select New Font" );
    if ( ok )
    {
        Current->Font[n] = f;
        AdjustFont( n );
        ApplyButton->setEnabled( TRUE );
    }
}

void settings::SelectFontColor()
{
    int n;

    n = FontGroup->id( FontGroup->selected() );
    QColor c = QColorDialog::getColor( Current->FontColor[n - 1], this, "Select New Font Color" );
    if ( c.isValid() )
    {
        Current->FontColor[ n-1 ] = c;
        AdjustFont( n );
        ApplyButton->setEnabled( TRUE );
    }
}

void settings::DefaultFont()
{
    int n;

    n = FontGroup->id( FontGroup->selected() );
    Current->Font[n] = Default->Font[n];
    if ( n > 0 && n < 3 )
    {
        Current->FontColor[n - 1] = Default->FontColor[n-1];
        ApplyButton->setEnabled( TRUE );
    }
    AdjustFont( n );
    FontDemoMultiLineEdit->setText("This is the pane for testing of the fonts and font colors...");
}

void settings::AdjustFont( int n )
{
    if ( n > 0 && n < 3 )
    {
        SelectColorButton->setEnabled( TRUE );
    }
    else
    {
        SelectColorButton->setEnabled( FALSE );
    }

    //FIRST ADJUST FONTS
    FontDemoMultiLineEdit->setFont( Current->Font[n] );

    //THEN COLORS
    if ( n == 0 || n > 3 )
    {
        FontDemoMultiLineEdit->setPalette( palEditDefault );
    }

    if ( n == 1 )
    {
        cgEdit = R->cgText;
        cgEdit.setColor( QColorGroup::Text, Current->FontColor[0] );
        palEdit.setActive( cgEdit );
        palEdit.setInactive( cgEdit );
        palEdit.setDisabled( cgEdit );
        FontDemoMultiLineEdit->setPalette( palEdit );
    }
    if ( n == 2 )
    {
        cgEdit = R->cgEdit;
        cgEdit.setColor( QColorGroup::Text, Current->FontColor[1] );
        palEdit.setActive( cgEdit );
        palEdit.setInactive( cgEdit );
        palEdit.setDisabled( cgEdit );
        FontDemoMultiLineEdit->setPalette( palEdit );
    }

    if ( n == 3 )
    {
        cgEdit = R->T->cg;
        cgEdit.setColor( QColorGroup::Text, Current->FontColor[2] );
        palEdit.setActive( cgEdit );
        palEdit.setInactive( cgEdit );
        palEdit.setDisabled( cgEdit );
        FontDemoMultiLineEdit->setPalette( palEdit );
    }
}

