/***************************************************************************
                          settings.h  -  description
                             -------------------
    begin                : Thu Aug 22 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SETTINGS_H
#define SETTINGS_H

#include <qvariant.h>
#include <qwidget.h>

#include "settingscue.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class QLCD;
class QLED;
class QLabel;
class QLineEdit;
class QTextEdit;
class QPushButton;
class QRadioButton;
class QTabWidget;

class RTMix;

class settings : public QWidget
{ 
    Q_OBJECT

public:
    settings( QWidget* parent = 0, const char* name = 0, WFlags fl = 0, RTMix *ptr = NULL );
    ~settings();

	QPixmap *Off;
	QPixmap *On;
	QPixmap *Warn;

	QPixmap Temp1;
	QPixmap Temp2;
	QPixmap Temp3;

    QPushButton* SpawnMidiButton;
    QLineEdit* MidiPortEdit;
    QLabel* MidiStatus;
    QLabel* MidiPortEditLabel;

    QPushButton* OKButton;
    QPushButton* SaveSettingsButton;
    QPushButton* DefaultsButton;
    QPushButton* CancelButton;
    QPushButton* ApplyButton;
    QPushButton* WhatsThisButton;
	QPushButton* CloseAllButton;
    QTabWidget* TabWidget;
    QWidget* tab;
    QGroupBox* ExternalsGroup;
    QLabel* ExternalEditorLabel;
    QLineEdit* ExternalEditorLineEdit;
    QGroupBox* ToggleControlsGroup;
    QButtonGroup* MetronomesGroup;
    QButtonGroup* OtherGroup;
    QCheckBox* Metro1CheckBox;
    QCheckBox* Metro2CheckBox;
    QCheckBox* Metro3CheckBox;
    QCheckBox* Metro4CheckBox;
    QButtonGroup* WarningWindowsGroup;
    QCheckBox* Window1CheckBox;
    QCheckBox* Window2CheckBox;
    QCheckBox* Window3CheckBox;
    QCheckBox* Window4CheckBox;
    QButtonGroup* MainWindowSizeGroup;
    QRadioButton* FullSizeMainRadio;
    QRadioButton* CompactMainRadio;
	QCheckBox* ExternTimerCheckBox;
    QCheckBox* ExternAbsTimerCheckBox;
    QCheckBox* LEDWindowCheckBox;
    QCheckBox* ExternalErrorLogCheckBox;
    QGroupBox* ShortcutsGroup;
    QLabel* SelectWidgetLabel;
    QComboBox* ShortcutComboBox;
    QLineEdit* NewShortcutLineEdit;
    //QPushButton* ApplyShortcutButton;
    QPushButton* DefaultShortcutButton;
    QFrame* CurrentShortcutFrame;
    QLabel* CurrentShortcutLabel;
    QLabel* CurrentShortcut;
    QLabel* NewShortcutLabel;
    QWidget* tab_2;
    QGroupBox* TimersGroup;
    QLabel* PreviewTimerLabel;
    QLabel* SelectTimerLabel;
    QLCD* PreviewLCD;
    QPushButton* SelectTimerColorBox;
    QComboBox* TimerComboBox;
    QPushButton* ResetTimerColorBox;
    //QPushButton* ApplyTimerColorBox;
    QGroupBox* ImagesGroup;
    QLabel* PreviewPixmapLabel;
    QLabel* WARNLabel;
    QLabel* OFFLabel;
    QLineEdit* WARNPixmapLineEdit;
    //QPushButton* ApplyPixmapButton;
    QPushButton* BrowseWARNButton;
    QPushButton* BrowseONButton;
    QPushButton* BrowseOFFButton;
    QLineEdit* OFFPixmapLineEdit;
    QLineEdit* ONPixmapLineEdit;
    QLabel* ONLabel;
    QLED* PreviewPixmap;
	QLabel* PreviewPixmapName;
    QPushButton* DefaultPixmapButton;
    QComboBox* PixmapComboBox;
    QLabel* SelectPixmapLabel;
    QWidget* Fonts;
    QLabel* VerticalArrow;
    QLabel* HorizontalArrow;
    QFrame* FontButtonsFrame;
    //QPushButton* ApplyFontButton;
    QPushButton* SelectFontButton;
    QPushButton* SelectColorButton;
    QPushButton* DefaultFontButton;
    QGroupBox* FontAppearanceGroup;
    QTextEdit* FontDemoMultiLineEdit;
    QButtonGroup* FontGroup;
    QRadioButton* GeneralFontRadio;
    QRadioButton* NotificationFontRadio;
    QRadioButton* EditorFontRadio;
    //QRadioButton* InternalErrorFontRadio;
    QRadioButton* ExternalErrorFontRadio;
    QRadioButton* WarningWindowFontRadio;
    QRadioButton* LEDWindowFontRadio;
    QRadioButton* MetroFontRadio;
    QWidget* About;
    QGroupBox* WidgetNamesGroup;
    QLabel* NewNameLabel;
    QComboBox* TextComboBox;
    QLabel* SelectTextLabel;
    QFrame* CurrentTextFrame;
    QLabel* CurrentNameLabel;
    QLabel* CurrentName;
    QLineEdit* NewNameLineEdit;
    //QPushButton* ApplyTimerColorBox_2;
    QPushButton* ResetTimerColorBox_2;
    QWidget* tab_3;
    QLabel* IcoLogo;
    QLabel* DesignedWithLabel;
    QLabel* QtLogo;
    QLabel* AuthorLabel;
    QTextEdit* LicenseMultiLineEdit;
    QLabel* RTMixLabel;
    QLabel* TuxLogo;

    QWidget* Net;
    QGroupBox* NetFrameGroup;
    QLabel* NetLabel;
    QLabel* FilterLabel;
    QLineEdit* NetAuthEdit;
    QTextEdit* Filter;
    //QWidget* Help;
    //QGroupBox* DocumentationGroup;
    //QLabel* Help1Label;
    //QLabel* Help2Label;
    //QGroupBox* HelpOption2Group;
    //QLabel* Option2Label1;
    //QPushButton* HTMLDocsButton;
    //QLineEdit* BrowserEdit;
    //QLabel* Option2Label2;
    //QGroupBox* HelpOption1Group;
    //QLabel* Option1Label;
    //QPushButton* TextDocsButton;

    QTabWidget* Help;
    QGroupBox* DocumentationGroup;
    QLineEdit* BrowserLineEdit;
    QLabel* SelectBrowserLabel;
    QLabel* HelpLabel;
    QPushButton* ViewHelpButton;

	QString GetAccel( int );
	QString GetEditor();
	QString GetMidiPort();

    QPalette palLCD;
    QColorGroup cgLCD;

    QPalette palEditDefault;
    QColorGroup cgEditDefault;
    QPalette palEdit;
    QColorGroup cgEdit;

    void UpdateWidgets( int );
    QString GetNetAuth();
    QString GetFilter();

protected:
    QVBoxLayout* MetronomesGroupLayout;
    QVBoxLayout* WarningWindowsGroupLayout;
    QVBoxLayout* MainWindowSizeGroupLayout;
    QVBoxLayout* OtherGroupLayout;
    QVBoxLayout* FontGroupLayout;
    bool event( QEvent* );
    void closeEvent( QCloseEvent *e );

	RTMix *R;

	int PixmapState;

private:
	settingscue *Current;
	settingscue *Saved;
	settingscue *Default;

	void FillDefaultSettings();
	void WriteSettings( struct settingscue * );

	void BrowsePixmap( int );
	void ChangePixmap( int, int, QString );
	void AdjustPixmapText( int, int );

	//TODO

public slots:
    void SaveSettings();
	void ReadSettings();
	void setWinSize ( int );

private slots:
	//GLOBALS
	void ApplyAllSettings();
	void OK();
	void HelpMode();
	void ResetAll();

	void ResetPixmap();
	void Close();

	void BrowsePixmapOff();
	void BrowsePixmapOn();
	void BrowsePixmapWarn();

	//WINDOW TOGGLES
	void ToggleWarning1( int );
	void ToggleWarning2( int );
	void ToggleWarning3( int );
	void ToggleWarning4( int );

	void ToggleMetro1( int );
	void ToggleMetro2( int );
	void ToggleMetro3( int );
	void ToggleMetro4( int );

	void ToggleLEDw( int );

	void ToggleTimer( int );
	void ToggleAbsTimer( int );

	void UpdateExternalEditor( const QString & );
	void ApplyNetAuth( const QString & );
	void ApplyFilter();
  
	void AdjustShortcut( int );
	void ApplyShortcut();
	void DefaultShortcut();

	void IncreaseLCD();
	void DecreaseLCD();
	void UpdatePreviewColor();
	void AdjustPreviewLCD( int );
	void DefaultColor();

	void AdjustPixmap( int );
	void UpdatePixmap();

	void SelectFont();
	void SelectFontColor();
	void DefaultFont();
	void AdjustFont( int );

	void AdjustName( int );
	void ApplyName();
	void DefaultName();

	void ApplyMidiPort();
	void ConnectMidi();
	//void OpenDoc();
	//void OpenHTMLDoc();

    void ResetApplyButton();
    void SpawnHelp();
    void ApplyBrowser();

	void CloseAll();
};

#endif // SETTINGS_H
