/***************************************************************************
                          warning.h  -  description
                             -------------------
    begin                : Mon Aug 12 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef WARNING_WINDOW_H
#define WARNING_WINDOW_H

#include <qvariant.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qabstractlayout.h>

#include "eventcue.h"
#include "QLED.h"

class QVBoxLayout;
class QHBoxLayout; 
class QGridLayout; 
class QLCDNumber;
class QLabel;

class Warning_Window : public QWidget
{ 
    Q_OBJECT

public:
    Warning_Window( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~Warning_Window();

    QPalette pal;
    QColorGroup cg;

    QLabel* WindowLabel;
    QLED* WarnLED;
    QLabel* TimerLeftEdge;
    QLCDNumber* NTime;
    QLabel* TimerRightEdge;

    QPixmap *LED;
	QPixmap *LEDYellow;
	QPixmap *LEDGreen;
    QPixmap LeftEdge;
    QPixmap RightEdge;

	//QSpacerItem LeftSpacer;
	//QSpacerItem RightSpacer;

    eventCue *EventPointer;
    long warnLength;

	int UpdateDisplay( struct eventCue* , long );
	void SetName( QString, QString );
	void ResetDisplay();
	void SetDisplay( struct eventCue* , long );
	void SetImage( QString, int ); //int is on or off image
    void InternalUpdate();

signals:
	void Closed( int );	
    void KeyPress( QKeyEvent* );
    void KeyRelease( QKeyEvent* );
protected:
    QGridLayout* Warning_WindowLayout;
    QHBoxLayout* LayoutChrono;
    bool event( QEvent* );
    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );
private:
	bool Status; //whether currently timer is receiving events
	bool LightStatus;
public slots:
    void SetResizable( bool );
};

#endif // WARNING_WINDOW_H
